/* command.c generated by valac 0.46.6, the Vala compiler
 * generated from command.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2018 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>

#define TYPE_COMMAND (command_get_type ())
#define COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMAND, Command))
#define COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMMAND, CommandClass))
#define IS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMAND))
#define IS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMMAND))
#define COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMMAND, CommandClass))

typedef struct _Command Command;
typedef struct _CommandClass CommandClass;
typedef struct _CommandPrivate CommandPrivate;
enum  {
	COMMAND_0_PROPERTY,
	COMMAND_NUM_PROPERTIES
};
static GParamSpec* command_properties[COMMAND_NUM_PROPERTIES];
typedef enum  {
	DEBUG_DOMAIN_ERROR,
	DEBUG_DOMAIN_INFO,
	DEBUG_DOMAIN_HAMACHI,
	DEBUG_DOMAIN_ENVIRONMENT,
	DEBUG_DOMAIN_GUI
} Debugdomain;

#define DEBUG_TYPE_DOMAIN (debug_domain_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_KEY (key_get_type ())
#define KEY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KEY, Key))
#define KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KEY, KeyClass))
#define IS_KEY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KEY))
#define IS_KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KEY))
#define KEY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KEY, KeyClass))

typedef struct _Key Key;
typedef struct _KeyClass KeyClass;

#define TYPE_MEMBER (member_get_type ())
#define MEMBER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEMBER, Member))
#define MEMBER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEMBER, MemberClass))
#define IS_MEMBER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEMBER))
#define IS_MEMBER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEMBER))
#define MEMBER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEMBER, MemberClass))

typedef struct _Member Member;
typedef struct _MemberClass MemberClass;
typedef struct _MemberPrivate MemberPrivate;

#define TYPE_STATUS (status_get_type ())
#define STATUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATUS, Status))
#define STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATUS, StatusClass))
#define IS_STATUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATUS))
#define IS_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATUS))
#define STATUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATUS, StatusClass))

typedef struct _Status Status;
typedef struct _StatusClass StatusClass;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _Command {
	GObject parent_instance;
	CommandPrivate * priv;
};

struct _CommandClass {
	GObjectClass parent_class;
};

struct _Member {
	GObject parent_instance;
	MemberPrivate * priv;
	Status* status;
	gchar* network_id;
	gchar* ipv4;
	gchar* ipv6;
	gchar* nick;
	gchar* client_id;
	gchar* tunnel;
	gchar* name_sort_string;
	gchar* status_sort_string;
	gboolean is_evicted;
};

struct _MemberClass {
	GObjectClass parent_class;
};

static gpointer command_parent_class = NULL;
extern gchar* command_sudo;
gchar* command_sudo = NULL;
extern gchar* command_sudo_args;
gchar* command_sudo_args = NULL;
extern gchar* command_sudo_start;
gchar* command_sudo_start = NULL;
extern gchar* command_terminal;
gchar* command_terminal = NULL;
extern gchar* command_file_manager;
gchar* command_file_manager = NULL;
extern gchar* command_remote_desktop;
gchar* command_remote_desktop = NULL;
extern Key* settings_super_user;
extern gchar* hamachi_ip_version;
extern Key* settings_custom_commands;

GType command_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Command, g_object_unref)
void command_init (void);
void command_determine_sudo (void);
void command_determine_terminal (void);
void command_determine_file_manager (void);
void command_determine_remote_desktop (void);
void command_execute (const gchar* command);
GType debug_domain_get_type (void) G_GNUC_CONST;
void debug_log (Debugdomain _domain,
                const gchar* reporter,
                const gchar* output);
gchar* command_return_output (const gchar* command);
gboolean command_exists (const gchar* command);
gboolean command_custom_exists (const gchar* command_ipv4,
                                const gchar* command_ipv6);
gchar* command_replace_variables (gchar* command,
                                  const gchar* address,
                                  const gchar* nick,
                                  const gchar* id);
GType key_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Key, g_object_unref)
GVariant* key_get_val (Key* self);
static gchar* _variant_get1 (GVariant* value);
static gchar* command_get_available (gchar** commands,
                              gint commands_length1);
#define TEXT_app_name "Haguichi"
GType member_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Member, g_object_unref)
gchar* command_return_custom (Member* member,
                              const gchar* command_ipv4,
                              const gchar* command_ipv6,
                              const gchar* priority);
GType status_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Status, g_object_unref)
gchar** command_return_default (gint* result_length1);
static gchar** _variant_get2 (GVariant* value,
                       gint* result_length1);
static gchar** _vala_array_dup2 (gchar** self,
                          int length);
gchar** command_return_by_number (gint number,
                                  gint* result_length1);
static gchar** _variant_get3 (GVariant* value,
                       gint* result_length1);
static gchar** _vala_array_dup3 (gchar** self,
                          int length);
void command_open_uri (const gchar* uri);
Command* command_new (void);
Command* command_construct (GType object_type);
static void command_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

void
command_init (void)
{
	command_determine_sudo ();
	command_determine_terminal ();
	command_determine_file_manager ();
	command_determine_remote_desktop ();
}

void
command_execute (const gchar* command)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (command != NULL);
	if (g_strcmp0 (command, "") == 0) {
		return;
	}
	{
		g_spawn_command_line_async (command, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
				goto __catch2_g_spawn_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	goto __finally2;
	__catch2_g_spawn_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp0_ = e;
		_tmp1_ = _tmp0_->message;
		debug_log (DEBUG_DOMAIN_ERROR, "Command.execute", _tmp1_);
		_g_error_free0 (e);
	}
	__finally2:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

gchar*
command_return_output (const gchar* command)
{
	gchar* output = NULL;
	gchar* _error_ = NULL;
	gint exit_status = 0;
	const gchar* _tmp11_;
	const gchar* _tmp13_;
	gboolean _tmp15_ = FALSE;
	const gchar* _tmp16_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (command != NULL, NULL);
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gint _tmp2_ = 0;
		const gchar* _tmp3_;
		g_spawn_command_line_sync (command, &_tmp0_, &_tmp1_, &_tmp2_, &_inner_error0_);
		_g_free0 (output);
		output = _tmp0_;
		_g_free0 (_error_);
		_error_ = _tmp1_;
		exit_status = _tmp2_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
				goto __catch3_g_spawn_error;
			}
			_g_free0 (_error_);
			_g_free0 (output);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp3_ = _error_;
		if (g_strcmp0 (_tmp3_, "") != 0) {
			const gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			_tmp4_ = _error_;
			_tmp5_ = g_strconcat ("stderr: ", _tmp4_, NULL);
			_tmp6_ = _tmp5_;
			debug_log (DEBUG_DOMAIN_ERROR, "Command.return_output", _tmp6_);
			_g_free0 (_tmp6_);
		}
	}
	goto __finally3;
	__catch3_g_spawn_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		const gchar* _tmp10_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		_tmp9_ = g_strdup (_tmp8_);
		_g_free0 (_error_);
		_error_ = _tmp9_;
		_tmp10_ = _error_;
		debug_log (DEBUG_DOMAIN_ERROR, "Command.return_output", _tmp10_);
		_g_error_free0 (e);
	}
	__finally3:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (_error_);
		_g_free0 (output);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_tmp11_ = output;
	if (_tmp11_ == NULL) {
		gchar* _tmp12_;
		_tmp12_ = g_strdup ("");
		_g_free0 (output);
		output = _tmp12_;
	}
	_tmp13_ = output;
	if (string_contains (_tmp13_, ".. failed, busy")) {
		gchar* _tmp14_;
		debug_log (DEBUG_DOMAIN_HAMACHI, "Command.return_output", "Hamachi is busy, waiting to try again...");
		g_usleep ((gulong) 100000);
		_tmp14_ = command_return_output (command);
		_g_free0 (output);
		output = _tmp14_;
	}
	_tmp16_ = output;
	if (g_strcmp0 (_tmp16_, "") == 0) {
		const gchar* _tmp17_;
		_tmp17_ = _error_;
		_tmp15_ = g_strcmp0 (_tmp17_, "") != 0;
	} else {
		_tmp15_ = FALSE;
	}
	if (_tmp15_) {
		result = _error_;
		_g_free0 (output);
		return result;
	} else {
		result = output;
		_g_free0 (_error_);
		return result;
	}
	_g_free0 (_error_);
	_g_free0 (output);
}

gboolean
command_exists (const gchar* command)
{
	gchar* output = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gboolean result = FALSE;
	if (command == NULL) {
		result = FALSE;
		return result;
	}
	_tmp0_ = g_strconcat ("bash -c \"command -v ", command, NULL);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strconcat (_tmp1_, " &>/dev/null || echo 'command not found'\"", NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = command_return_output (_tmp3_);
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	output = _tmp5_;
	_tmp6_ = output;
	if (string_contains (_tmp6_, "command not found")) {
		result = FALSE;
		_g_free0 (output);
		return result;
	} else {
		result = TRUE;
		_g_free0 (output);
		return result;
	}
	_g_free0 (output);
}

gboolean
command_custom_exists (const gchar* command_ipv4,
                       const gchar* command_ipv6)
{
	gboolean _tmp0_ = FALSE;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	const gchar* _tmp7_;
	gboolean _tmp8_;
	gboolean result = FALSE;
	g_return_val_if_fail (command_ipv4 != NULL, FALSE);
	g_return_val_if_fail (command_ipv6 != NULL, FALSE);
	_tmp1_ = g_strdup (command_ipv4);
	_tmp2_ = command_replace_variables (_tmp1_, "", "", "");
	_tmp3_ = _tmp2_;
	_tmp5_ = _tmp4_ = g_strsplit (_tmp3_, " ", 0);
	_tmp6_ = _tmp5_;
	_tmp6__length1 = _vala_array_length (_tmp4_);
	_tmp7_ = _tmp6_[0];
	_tmp8_ = command_exists (_tmp7_);
	_tmp6_ = (_vala_array_free (_tmp6_, _tmp6__length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (_tmp3_);
	if (_tmp8_) {
		_tmp0_ = TRUE;
	} else {
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar** _tmp12_;
		gchar** _tmp13_;
		gchar** _tmp14_;
		gint _tmp14__length1;
		const gchar* _tmp15_;
		_tmp9_ = g_strdup (command_ipv6);
		_tmp10_ = command_replace_variables (_tmp9_, "", "", "");
		_tmp11_ = _tmp10_;
		_tmp13_ = _tmp12_ = g_strsplit (_tmp11_, " ", 0);
		_tmp14_ = _tmp13_;
		_tmp14__length1 = _vala_array_length (_tmp12_);
		_tmp15_ = _tmp14_[0];
		_tmp0_ = command_exists (_tmp15_);
		_tmp14_ = (_vala_array_free (_tmp14_, _tmp14__length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (_tmp11_);
	}
	if (_tmp0_) {
		result = TRUE;
		return result;
	} else {
		result = FALSE;
		return result;
	}
}

static gchar*
_variant_get1 (GVariant* value)
{
	return g_variant_dup_string (value, NULL);
}

void
command_determine_sudo (void)
{
	Key* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp17_;
	const gchar* _tmp21_;
	_tmp0_ = settings_super_user;
	_tmp1_ = key_get_val (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _variant_get1 (_tmp2_);
	_g_free0 (command_sudo);
	command_sudo = _tmp3_;
	_tmp4_ = g_strdup ("");
	_g_free0 (command_sudo_args);
	command_sudo_args = _tmp4_;
	_tmp5_ = g_strdup ("-- ");
	_g_free0 (command_sudo_start);
	command_sudo_start = _tmp5_;
	_tmp6_ = command_sudo;
	if (g_strcmp0 (_tmp6_, "auto") == 0) {
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar** _tmp14_;
		gchar** _tmp15_;
		gint _tmp15__length1;
		gchar* _tmp16_;
		_tmp7_ = g_strdup ("pkexec");
		_tmp8_ = g_strdup ("gksudo");
		_tmp9_ = g_strdup ("gksu");
		_tmp10_ = g_strdup ("gnomesu");
		_tmp11_ = g_strdup ("kdesudo");
		_tmp12_ = g_strdup ("kdesu");
		_tmp13_ = g_strdup ("sudo");
		_tmp14_ = g_new0 (gchar*, 7 + 1);
		_tmp14_[0] = _tmp7_;
		_tmp14_[1] = _tmp8_;
		_tmp14_[2] = _tmp9_;
		_tmp14_[3] = _tmp10_;
		_tmp14_[4] = _tmp11_;
		_tmp14_[5] = _tmp12_;
		_tmp14_[6] = _tmp13_;
		_tmp15_ = _tmp14_;
		_tmp15__length1 = 7;
		_tmp16_ = command_get_available (_tmp15_, (gint) 7);
		_g_free0 (command_sudo);
		command_sudo = _tmp16_;
		_tmp15_ = (_vala_array_free (_tmp15_, _tmp15__length1, (GDestroyNotify) g_free), NULL);
	}
	_tmp17_ = command_sudo;
	if (g_strcmp0 (_tmp17_, "pkexec") == 0) {
		gchar* _tmp18_;
		_tmp18_ = g_strdup ("");
		_g_free0 (command_sudo_start);
		command_sudo_start = _tmp18_;
	} else {
		const gchar* _tmp19_;
		_tmp19_ = command_sudo;
		if (g_str_has_prefix (_tmp19_, "gksu")) {
			gchar* _tmp20_;
			_tmp20_ = g_strdup ("--sudo-mode -D \"" TEXT_app_name "\" ");
			_g_free0 (command_sudo_args);
			command_sudo_args = _tmp20_;
		}
	}
	_tmp21_ = command_sudo;
	debug_log (DEBUG_DOMAIN_ENVIRONMENT, "Command.determine_sudo", _tmp21_);
}

static gchar*
command_get_available (gchar** commands,
                       gint commands_length1)
{
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result = NULL;
	{
		gchar** cmd_collection = NULL;
		gint cmd_collection_length1 = 0;
		gint _cmd_collection_size_ = 0;
		gint cmd_it = 0;
		cmd_collection = commands;
		cmd_collection_length1 = commands_length1;
		for (cmd_it = 0; cmd_it < cmd_collection_length1; cmd_it = cmd_it + 1) {
			gchar* _tmp0_;
			gchar* cmd = NULL;
			_tmp0_ = g_strdup (cmd_collection[cmd_it]);
			cmd = _tmp0_;
			{
				const gchar* _tmp1_;
				_tmp1_ = cmd;
				if (command_exists (_tmp1_)) {
					result = cmd;
					return result;
				}
				_g_free0 (cmd);
			}
		}
	}
	_tmp2_ = commands[0];
	_tmp3_ = g_strdup (_tmp2_);
	result = _tmp3_;
	return result;
}

void
command_determine_terminal (void)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar** _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	_tmp0_ = g_strdup ("gnome-terminal");
	_tmp1_ = g_strdup ("mate-terminal");
	_tmp2_ = g_strdup ("pantheon-terminal");
	_tmp3_ = g_strdup ("io.elementary.terminal");
	_tmp4_ = g_strdup ("xfce4-terminal");
	_tmp5_ = g_strdup ("konsole");
	_tmp6_ = g_strdup ("deepin-terminal");
	_tmp7_ = g_strdup ("qterminal");
	_tmp8_ = g_strdup ("lxterminal");
	_tmp9_ = g_strdup ("uxterm");
	_tmp10_ = g_strdup ("xterm");
	_tmp11_ = g_new0 (gchar*, 11 + 1);
	_tmp11_[0] = _tmp0_;
	_tmp11_[1] = _tmp1_;
	_tmp11_[2] = _tmp2_;
	_tmp11_[3] = _tmp3_;
	_tmp11_[4] = _tmp4_;
	_tmp11_[5] = _tmp5_;
	_tmp11_[6] = _tmp6_;
	_tmp11_[7] = _tmp7_;
	_tmp11_[8] = _tmp8_;
	_tmp11_[9] = _tmp9_;
	_tmp11_[10] = _tmp10_;
	_tmp12_ = _tmp11_;
	_tmp12__length1 = 11;
	_tmp13_ = command_get_available (_tmp12_, (gint) 11);
	_g_free0 (command_terminal);
	command_terminal = _tmp13_;
	_tmp12_ = (_vala_array_free (_tmp12_, _tmp12__length1, (GDestroyNotify) g_free), NULL);
	_tmp14_ = command_terminal;
	debug_log (DEBUG_DOMAIN_ENVIRONMENT, "Command.determine_terminal", _tmp14_);
}

void
command_determine_file_manager (void)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar** _tmp10_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	_tmp0_ = g_strdup ("nautilus");
	_tmp1_ = g_strdup ("caja");
	_tmp2_ = g_strdup ("nemo");
	_tmp3_ = g_strdup ("pantheon-files");
	_tmp4_ = g_strdup ("io.elementary.files");
	_tmp5_ = g_strdup ("thunar");
	_tmp6_ = g_strdup ("dolphin");
	_tmp7_ = g_strdup ("dde-file-manager");
	_tmp8_ = g_strdup ("pcmanfm-qt");
	_tmp9_ = g_strdup ("pcmanfm");
	_tmp10_ = g_new0 (gchar*, 10 + 1);
	_tmp10_[0] = _tmp0_;
	_tmp10_[1] = _tmp1_;
	_tmp10_[2] = _tmp2_;
	_tmp10_[3] = _tmp3_;
	_tmp10_[4] = _tmp4_;
	_tmp10_[5] = _tmp5_;
	_tmp10_[6] = _tmp6_;
	_tmp10_[7] = _tmp7_;
	_tmp10_[8] = _tmp8_;
	_tmp10_[9] = _tmp9_;
	_tmp11_ = _tmp10_;
	_tmp11__length1 = 10;
	_tmp12_ = command_get_available (_tmp11_, (gint) 10);
	_g_free0 (command_file_manager);
	command_file_manager = _tmp12_;
	_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
	_tmp13_ = command_file_manager;
	debug_log (DEBUG_DOMAIN_ENVIRONMENT, "Command.determine_file_manager", _tmp13_);
}

void
command_determine_remote_desktop (void)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	_tmp0_ = g_strdup ("vinagre");
	_tmp1_ = g_strdup ("gvncviewer");
	_tmp2_ = g_strdup ("krdc");
	_tmp3_ = g_strdup ("vncviewer");
	_tmp4_ = g_strdup ("xtightvncviewer");
	_tmp5_ = g_strdup ("xvnc4viewer");
	_tmp6_ = g_strdup ("rdesktop");
	_tmp7_ = g_new0 (gchar*, 7 + 1);
	_tmp7_[0] = _tmp0_;
	_tmp7_[1] = _tmp1_;
	_tmp7_[2] = _tmp2_;
	_tmp7_[3] = _tmp3_;
	_tmp7_[4] = _tmp4_;
	_tmp7_[5] = _tmp5_;
	_tmp7_[6] = _tmp6_;
	_tmp8_ = _tmp7_;
	_tmp8__length1 = 7;
	_tmp9_ = command_get_available (_tmp8_, (gint) 7);
	_g_free0 (command_remote_desktop);
	command_remote_desktop = _tmp9_;
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
	_tmp10_ = command_remote_desktop;
	debug_log (DEBUG_DOMAIN_ENVIRONMENT, "Command.determine_remote_desktop", _tmp10_);
}

gchar*
command_return_custom (Member* member,
                       const gchar* command_ipv4,
                       const gchar* command_ipv6,
                       const gchar* priority)
{
	gchar* command = NULL;
	gchar* _tmp0_;
	gchar* address = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* result = NULL;
	g_return_val_if_fail (command_ipv4 != NULL, NULL);
	g_return_val_if_fail (command_ipv6 != NULL, NULL);
	g_return_val_if_fail (priority != NULL, NULL);
	_tmp0_ = g_strdup ("");
	command = _tmp0_;
	_tmp1_ = g_strdup ("");
	address = _tmp1_;
	_tmp2_ = hamachi_ip_version;
	if (g_strcmp0 (_tmp2_, "Both") == 0) {
		if (g_strcmp0 (priority, "IPv4") == 0) {
			const gchar* _tmp3_;
			_tmp3_ = member->ipv4;
			if (_tmp3_ != NULL) {
				gchar* _tmp4_;
				const gchar* _tmp5_;
				gchar* _tmp6_;
				_tmp4_ = g_strdup (command_ipv4);
				_g_free0 (command);
				command = _tmp4_;
				_tmp5_ = member->ipv4;
				_tmp6_ = g_strdup (_tmp5_);
				_g_free0 (address);
				address = _tmp6_;
			} else {
				gchar* _tmp7_;
				const gchar* _tmp8_;
				gchar* _tmp9_;
				_tmp7_ = g_strdup (command_ipv6);
				_g_free0 (command);
				command = _tmp7_;
				_tmp8_ = member->ipv6;
				_tmp9_ = g_strdup (_tmp8_);
				_g_free0 (address);
				address = _tmp9_;
			}
		}
		if (g_strcmp0 (priority, "IPv6") == 0) {
			const gchar* _tmp10_;
			_tmp10_ = member->ipv6;
			if (_tmp10_ != NULL) {
				gchar* _tmp11_;
				const gchar* _tmp12_;
				gchar* _tmp13_;
				_tmp11_ = g_strdup (command_ipv6);
				_g_free0 (command);
				command = _tmp11_;
				_tmp12_ = member->ipv6;
				_tmp13_ = g_strdup (_tmp12_);
				_g_free0 (address);
				address = _tmp13_;
			} else {
				gchar* _tmp14_;
				const gchar* _tmp15_;
				gchar* _tmp16_;
				_tmp14_ = g_strdup (command_ipv4);
				_g_free0 (command);
				command = _tmp14_;
				_tmp15_ = member->ipv4;
				_tmp16_ = g_strdup (_tmp15_);
				_g_free0 (address);
				address = _tmp16_;
			}
		}
	} else {
		const gchar* _tmp17_;
		_tmp17_ = hamachi_ip_version;
		if (g_strcmp0 (_tmp17_, "IPv4") == 0) {
			gchar* _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
			_tmp18_ = g_strdup (command_ipv4);
			_g_free0 (command);
			command = _tmp18_;
			_tmp19_ = member->ipv4;
			_tmp20_ = g_strdup (_tmp19_);
			_g_free0 (address);
			address = _tmp20_;
		} else {
			const gchar* _tmp21_;
			_tmp21_ = hamachi_ip_version;
			if (g_strcmp0 (_tmp21_, "IPv6") == 0) {
				gchar* _tmp22_;
				const gchar* _tmp23_;
				gchar* _tmp24_;
				_tmp22_ = g_strdup (command_ipv6);
				_g_free0 (command);
				command = _tmp22_;
				_tmp23_ = member->ipv6;
				_tmp24_ = g_strdup (_tmp23_);
				_g_free0 (address);
				address = _tmp24_;
			}
		}
	}
	_tmp25_ = command;
	_tmp26_ = g_strdup (_tmp25_);
	_tmp27_ = address;
	_tmp28_ = member->nick;
	_tmp29_ = member->client_id;
	_tmp30_ = command_replace_variables (_tmp26_, _tmp27_, _tmp28_, _tmp29_);
	result = _tmp30_;
	_g_free0 (address);
	_g_free0 (command);
	return result;
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch5_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch5_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally5;
	__catch5_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally5:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

gchar*
command_replace_variables (gchar* command,
                           const gchar* address,
                           const gchar* nick,
                           const gchar* id)
{
	gchar* _tmp38_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (command != NULL, NULL);
	g_return_val_if_fail (address != NULL, NULL);
	g_return_val_if_fail (nick != NULL, NULL);
	g_return_val_if_fail (id != NULL, NULL);
	{
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_ = NULL;
		const gchar* _tmp4_;
		gchar* execute = NULL;
		gchar* _tmp5_;
		const gchar* _tmp6_ = NULL;
		const gchar* _tmp7_;
		gchar* quote = NULL;
		gchar* _tmp8_;
		GRegex* _tmp9_ = NULL;
		GRegex* _tmp10_;
		gchar* _tmp11_ = NULL;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		const gchar* _tmp31_;
		gchar* _tmp32_;
		const gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		_tmp0_ = string_replace (command, "%A", address);
		_g_free0 (command);
		command = _tmp0_;
		_tmp1_ = string_replace (command, "%N", nick);
		_g_free0 (command);
		command = _tmp1_;
		_tmp2_ = string_replace (command, "%ID", id);
		_g_free0 (command);
		command = _tmp2_;
		_tmp4_ = command_terminal;
		if (g_strcmp0 (_tmp4_, "gnome-terminal") == 0) {
			_tmp3_ = "--";
		} else {
			_tmp3_ = "-e";
		}
		_tmp5_ = g_strdup (_tmp3_);
		execute = _tmp5_;
		_tmp7_ = command_terminal;
		if (g_strcmp0 (_tmp7_, "gnome-terminal") == 0) {
			_tmp6_ = "";
		} else {
			_tmp6_ = "\"";
		}
		_tmp8_ = g_strdup (_tmp6_);
		quote = _tmp8_;
		_tmp10_ = g_regex_new ("%TERMINAL (.*)", 0, 0, &_inner_error0_);
		_tmp9_ = _tmp10_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (quote);
			_g_free0 (execute);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch4_g_regex_error;
			}
			_g_free0 (command);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp12_ = command_terminal;
		_tmp13_ = g_strconcat (_tmp12_, " ", NULL);
		_tmp14_ = _tmp13_;
		_tmp15_ = execute;
		_tmp16_ = g_strconcat (_tmp14_, _tmp15_, NULL);
		_tmp17_ = _tmp16_;
		_tmp18_ = g_strconcat (_tmp17_, " ", NULL);
		_tmp19_ = _tmp18_;
		_tmp20_ = quote;
		_tmp21_ = g_strconcat (_tmp19_, _tmp20_, NULL);
		_tmp22_ = _tmp21_;
		_tmp23_ = g_strconcat (_tmp22_, "\\1", NULL);
		_tmp24_ = _tmp23_;
		_tmp25_ = quote;
		_tmp26_ = g_strconcat (_tmp24_, _tmp25_, NULL);
		_tmp27_ = _tmp26_;
		_tmp28_ = g_regex_replace (_tmp9_, command, (gssize) -1, 0, _tmp27_, 0, &_inner_error0_);
		_tmp29_ = _tmp28_;
		_g_free0 (_tmp27_);
		_g_free0 (_tmp24_);
		_g_free0 (_tmp22_);
		_g_free0 (_tmp19_);
		_g_free0 (_tmp17_);
		_g_free0 (_tmp14_);
		_tmp11_ = _tmp29_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (_tmp9_);
			_g_free0 (quote);
			_g_free0 (execute);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch4_g_regex_error;
			}
			_g_free0 (command);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp30_ = _tmp11_;
		_tmp11_ = NULL;
		_g_free0 (command);
		command = _tmp30_;
		_tmp31_ = command_file_manager;
		_tmp32_ = string_replace (command, "%FILEMANAGER", _tmp31_);
		_g_free0 (command);
		command = _tmp32_;
		_tmp33_ = command_remote_desktop;
		_tmp34_ = string_replace (command, "%REMOTEDESKTOP", _tmp33_);
		_g_free0 (command);
		command = _tmp34_;
		_tmp35_ = string_replace (command, "{COLON}", ";");
		_g_free0 (command);
		command = _tmp35_;
		_g_free0 (_tmp11_);
		_g_regex_unref0 (_tmp9_);
		_g_free0 (quote);
		_g_free0 (execute);
	}
	goto __finally4;
	__catch4_g_regex_error:
	{
		GError* e = NULL;
		GError* _tmp36_;
		const gchar* _tmp37_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp36_ = e;
		_tmp37_ = _tmp36_->message;
		debug_log (DEBUG_DOMAIN_ERROR, "Command.replace_variables", _tmp37_);
		_g_error_free0 (e);
	}
	__finally4:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (command);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_tmp38_ = g_strdup (command);
	result = _tmp38_;
	_g_free0 (command);
	return result;
}

static gchar**
_variant_get2 (GVariant* value,
               gint* result_length1)
{
	gchar** _tmp6_;
	gint _tmp6__length;
	gint _tmp6__size;
	gint _tmp6__length1;
	GVariantIter _tmp7_;
	GVariant* _tmp8_;
	_tmp6_ = g_new (gchar*, 5);
	_tmp6__length = 0;
	_tmp6__size = 4;
	_tmp6__length1 = 0;
	g_variant_iter_init (&_tmp7_, value);
	for (; (_tmp8_ = g_variant_iter_next_value (&_tmp7_)) != NULL; _tmp6__length1++) {
		if (_tmp6__size == _tmp6__length) {
			_tmp6__size = 2 * _tmp6__size;
			_tmp6_ = g_renew (gchar*, _tmp6_, _tmp6__size + 1);
		}
		_tmp6_[_tmp6__length++] = g_variant_dup_string (_tmp8_, NULL);
		g_variant_unref (_tmp8_);
	}
	*result_length1 = _tmp6__length1;
	_tmp6_[_tmp6__length] = NULL;
	return _tmp6_;
}

static gchar**
_vala_array_dup2 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}

gchar**
command_return_default (gint* result_length1)
{
	gchar** command = NULL;
	gchar* _tmp0_;
	gchar** _tmp1_;
	gint command_length1;
	gint _command_size_;
	gchar** commands = NULL;
	Key* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	gchar** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	gint commands_length1;
	gint _commands_size_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gchar** _tmp25_;
	gint _tmp25__length1;
	gchar** result = NULL;
	_tmp0_ = g_strdup ("");
	_tmp1_ = g_new0 (gchar*, 1 + 1);
	_tmp1_[0] = _tmp0_;
	command = _tmp1_;
	command_length1 = 1;
	_command_size_ = command_length1;
	_tmp2_ = settings_custom_commands;
	_tmp3_ = key_get_val (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = _variant_get2 (_tmp4_, &_tmp5__length1);
	commands = _tmp5_;
	commands_length1 = _tmp5__length1;
	_commands_size_ = commands_length1;
	_tmp9_ = commands;
	_tmp9__length1 = commands_length1;
	{
		gchar** _string_collection = NULL;
		gint _string_collection_length1 = 0;
		gint __string_collection_size_ = 0;
		gint _string_it = 0;
		_string_collection = _tmp9_;
		_string_collection_length1 = _tmp9__length1;
		for (_string_it = 0; _string_it < _string_collection_length1; _string_it = _string_it + 1) {
			gchar* _tmp10_;
			gchar* _string = NULL;
			_tmp10_ = g_strdup (_string_collection[_string_it]);
			_string = _tmp10_;
			{
				gchar** _array = NULL;
				const gchar* _tmp11_;
				gchar** _tmp12_;
				gchar** _tmp13_;
				gint _array_length1;
				gint __array_size_;
				gboolean _tmp14_ = FALSE;
				gboolean _tmp15_ = FALSE;
				gchar** _tmp16_;
				gint _tmp16__length1;
				_tmp11_ = _string;
				_tmp13_ = _tmp12_ = g_strsplit (_tmp11_, ";", 6);
				_array = _tmp13_;
				_array_length1 = _vala_array_length (_tmp12_);
				__array_size_ = _array_length1;
				_tmp16_ = _array;
				_tmp16__length1 = _array_length1;
				if (_tmp16__length1 == 6) {
					gchar** _tmp17_;
					gint _tmp17__length1;
					const gchar* _tmp18_;
					_tmp17_ = _array;
					_tmp17__length1 = _array_length1;
					_tmp18_ = _tmp17_[1];
					_tmp15_ = g_strcmp0 (_tmp18_, "true") == 0;
				} else {
					_tmp15_ = FALSE;
				}
				if (_tmp15_) {
					gchar** _tmp19_;
					gint _tmp19__length1;
					const gchar* _tmp20_;
					gchar** _tmp21_;
					gint _tmp21__length1;
					const gchar* _tmp22_;
					_tmp19_ = _array;
					_tmp19__length1 = _array_length1;
					_tmp20_ = _tmp19_[3];
					_tmp21_ = _array;
					_tmp21__length1 = _array_length1;
					_tmp22_ = _tmp21_[4];
					_tmp14_ = command_custom_exists (_tmp20_, _tmp22_);
				} else {
					_tmp14_ = FALSE;
				}
				if (_tmp14_) {
					gchar** _tmp23_;
					gint _tmp23__length1;
					gchar** _tmp24_;
					gint _tmp24__length1;
					_tmp23_ = _array;
					_tmp23__length1 = _array_length1;
					_tmp24_ = (_tmp23_ != NULL) ? _vala_array_dup2 (_tmp23_, _tmp23__length1) : ((gpointer) _tmp23_);
					_tmp24__length1 = _tmp23__length1;
					command = (_vala_array_free (command, command_length1, (GDestroyNotify) g_free), NULL);
					command = _tmp24_;
					command_length1 = _tmp24__length1;
					_command_size_ = command_length1;
				}
				_array = (_vala_array_free (_array, _array_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (_string);
			}
		}
	}
	_tmp25_ = command;
	_tmp25__length1 = command_length1;
	if (result_length1) {
		*result_length1 = _tmp25__length1;
	}
	result = _tmp25_;
	commands = (_vala_array_free (commands, commands_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

static gchar**
_variant_get3 (GVariant* value,
               gint* result_length1)
{
	gchar** _tmp6_;
	gint _tmp6__length;
	gint _tmp6__size;
	gint _tmp6__length1;
	GVariantIter _tmp7_;
	GVariant* _tmp8_;
	_tmp6_ = g_new (gchar*, 5);
	_tmp6__length = 0;
	_tmp6__size = 4;
	_tmp6__length1 = 0;
	g_variant_iter_init (&_tmp7_, value);
	for (; (_tmp8_ = g_variant_iter_next_value (&_tmp7_)) != NULL; _tmp6__length1++) {
		if (_tmp6__size == _tmp6__length) {
			_tmp6__size = 2 * _tmp6__size;
			_tmp6_ = g_renew (gchar*, _tmp6_, _tmp6__size + 1);
		}
		_tmp6_[_tmp6__length++] = g_variant_dup_string (_tmp8_, NULL);
		g_variant_unref (_tmp8_);
	}
	*result_length1 = _tmp6__length1;
	_tmp6_[_tmp6__length] = NULL;
	return _tmp6_;
}

static gchar**
_vala_array_dup3 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}

gchar**
command_return_by_number (gint number,
                          gint* result_length1)
{
	gchar** command = NULL;
	gchar* _tmp0_;
	gchar** _tmp1_;
	gint command_length1;
	gint _command_size_;
	gchar** commands = NULL;
	Key* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	gchar** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	gint commands_length1;
	gint _commands_size_;
	gint count = 0;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gchar** _tmp26_;
	gint _tmp26__length1;
	gchar** result = NULL;
	_tmp0_ = g_strdup ("");
	_tmp1_ = g_new0 (gchar*, 1 + 1);
	_tmp1_[0] = _tmp0_;
	command = _tmp1_;
	command_length1 = 1;
	_command_size_ = command_length1;
	_tmp2_ = settings_custom_commands;
	_tmp3_ = key_get_val (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = _variant_get3 (_tmp4_, &_tmp5__length1);
	commands = _tmp5_;
	commands_length1 = _tmp5__length1;
	_commands_size_ = commands_length1;
	count = 0;
	_tmp9_ = commands;
	_tmp9__length1 = commands_length1;
	{
		gchar** _string_collection = NULL;
		gint _string_collection_length1 = 0;
		gint __string_collection_size_ = 0;
		gint _string_it = 0;
		_string_collection = _tmp9_;
		_string_collection_length1 = _tmp9__length1;
		for (_string_it = 0; _string_it < _string_collection_length1; _string_it = _string_it + 1) {
			gchar* _tmp10_;
			gchar* _string = NULL;
			_tmp10_ = g_strdup (_string_collection[_string_it]);
			_string = _tmp10_;
			{
				gchar** _array = NULL;
				const gchar* _tmp11_;
				gchar** _tmp12_;
				gchar** _tmp13_;
				gint _array_length1;
				gint __array_size_;
				gboolean _tmp14_ = FALSE;
				gboolean _tmp15_ = FALSE;
				gchar** _tmp16_;
				gint _tmp16__length1;
				_tmp11_ = _string;
				_tmp13_ = _tmp12_ = g_strsplit (_tmp11_, ";", 6);
				_array = _tmp13_;
				_array_length1 = _vala_array_length (_tmp12_);
				__array_size_ = _array_length1;
				_tmp16_ = _array;
				_tmp16__length1 = _array_length1;
				if (_tmp16__length1 == 6) {
					gchar** _tmp17_;
					gint _tmp17__length1;
					const gchar* _tmp18_;
					_tmp17_ = _array;
					_tmp17__length1 = _array_length1;
					_tmp18_ = _tmp17_[0];
					_tmp15_ = g_strcmp0 (_tmp18_, "true") == 0;
				} else {
					_tmp15_ = FALSE;
				}
				if (_tmp15_) {
					gchar** _tmp19_;
					gint _tmp19__length1;
					const gchar* _tmp20_;
					gchar** _tmp21_;
					gint _tmp21__length1;
					const gchar* _tmp22_;
					_tmp19_ = _array;
					_tmp19__length1 = _array_length1;
					_tmp20_ = _tmp19_[3];
					_tmp21_ = _array;
					_tmp21__length1 = _array_length1;
					_tmp22_ = _tmp21_[4];
					_tmp14_ = command_custom_exists (_tmp20_, _tmp22_);
				} else {
					_tmp14_ = FALSE;
				}
				if (_tmp14_) {
					gint _tmp23_;
					_tmp23_ = count;
					count = _tmp23_ + 1;
					if (count == number) {
						gchar** _tmp24_;
						gint _tmp24__length1;
						gchar** _tmp25_;
						gint _tmp25__length1;
						_tmp24_ = _array;
						_tmp24__length1 = _array_length1;
						_tmp25_ = (_tmp24_ != NULL) ? _vala_array_dup3 (_tmp24_, _tmp24__length1) : ((gpointer) _tmp24_);
						_tmp25__length1 = _tmp24__length1;
						command = (_vala_array_free (command, command_length1, (GDestroyNotify) g_free), NULL);
						command = _tmp25_;
						command_length1 = _tmp25__length1;
						_command_size_ = command_length1;
					}
				}
				_array = (_vala_array_free (_array, _array_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (_string);
			}
		}
	}
	_tmp26_ = command;
	_tmp26__length1 = command_length1;
	if (result_length1) {
		*result_length1 = _tmp26__length1;
	}
	result = _tmp26_;
	commands = (_vala_array_free (commands, commands_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

void
command_open_uri (const gchar* uri)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (uri != NULL);
	{
		gtk_show_uri (NULL, uri, (guint32) GDK_CURRENT_TIME, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch6_g_error;
		}
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp0_ = e;
		_tmp1_ = _tmp0_->message;
		debug_log (DEBUG_DOMAIN_ERROR, "Command.open_uri", _tmp1_);
		if (command_exists ("xdg-open")) {
			gchar* _tmp2_;
			gchar* _tmp3_;
			debug_log (DEBUG_DOMAIN_ENVIRONMENT, "Command.open_uri", "Falling back to xdg-open");
			_tmp2_ = g_strconcat ("xdg-open ", uri, NULL);
			_tmp3_ = _tmp2_;
			command_execute (_tmp3_);
			_g_free0 (_tmp3_);
		}
		_g_error_free0 (e);
	}
	__finally6:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

Command*
command_construct (GType object_type)
{
	Command * self = NULL;
	self = (Command*) g_object_new (object_type, NULL);
	return self;
}

Command*
command_new (void)
{
	return command_construct (TYPE_COMMAND);
}

static void
command_class_init (CommandClass * klass,
                    gpointer klass_data)
{
	command_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = command_finalize;
}

static void
command_instance_init (Command * self,
                       gpointer klass)
{
}

static void
command_finalize (GObject * obj)
{
	Command * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COMMAND, Command);
	G_OBJECT_CLASS (command_parent_class)->finalize (obj);
}

GType
command_get_type (void)
{
	static volatile gsize command_type_id__volatile = 0;
	if (g_once_init_enter (&command_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Command), 0, (GInstanceInitFunc) command_instance_init, NULL };
		GType command_type_id;
		command_type_id = g_type_register_static (G_TYPE_OBJECT, "Command", &g_define_type_info, 0);
		g_once_init_leave (&command_type_id__volatile, command_type_id);
	}
	return command_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

