/* debug.c generated by valac 0.46.6, the Vala compiler
 * generated from debug.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2018 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <stdio.h>

#define TYPE_DEBUG (debug_get_type ())
#define DEBUG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DEBUG, Debug))
#define DEBUG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DEBUG, DebugClass))
#define IS_DEBUG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DEBUG))
#define IS_DEBUG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DEBUG))
#define DEBUG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DEBUG, DebugClass))

typedef struct _Debug Debug;
typedef struct _DebugClass DebugClass;
typedef struct _DebugPrivate DebugPrivate;
enum  {
	DEBUG_0_PROPERTY,
	DEBUG_NUM_PROPERTIES
};
static GParamSpec* debug_properties[DEBUG_NUM_PROPERTIES];
typedef enum  {
	DEBUG_DOMAIN_ERROR,
	DEBUG_DOMAIN_INFO,
	DEBUG_DOMAIN_HAMACHI,
	DEBUG_DOMAIN_ENVIRONMENT,
	DEBUG_DOMAIN_GUI
} Debugdomain;

#define DEBUG_TYPE_DOMAIN (debug_domain_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _Debug {
	GObject parent_instance;
	DebugPrivate * priv;
};

struct _DebugClass {
	GObjectClass parent_class;
};

static gpointer debug_parent_class = NULL;
extern gboolean haguichi_debugging;

GType debug_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Debug, g_object_unref)
GType debug_domain_get_type (void) G_GNUC_CONST;
void debug_log (Debugdomain _domain,
                const gchar* reporter,
                const gchar* output);
static gchar* debug_domain_color (Debugdomain _domain);
static gchar* debug_domain_name (Debugdomain _domain);
Debug* debug_new (void);
Debug* debug_construct (GType object_type);

GType
debug_domain_get_type (void)
{
	static volatile gsize debug_domain_type_id__volatile = 0;
	if (g_once_init_enter (&debug_domain_type_id__volatile)) {
		static const GEnumValue values[] = {{DEBUG_DOMAIN_ERROR, "DEBUG_DOMAIN_ERROR", "error"}, {DEBUG_DOMAIN_INFO, "DEBUG_DOMAIN_INFO", "info"}, {DEBUG_DOMAIN_HAMACHI, "DEBUG_DOMAIN_HAMACHI", "hamachi"}, {DEBUG_DOMAIN_ENVIRONMENT, "DEBUG_DOMAIN_ENVIRONMENT", "environment"}, {DEBUG_DOMAIN_GUI, "DEBUG_DOMAIN_GUI", "gui"}, {0, NULL, NULL}};
		GType debug_domain_type_id;
		debug_domain_type_id = g_enum_register_static ("Debugdomain", values);
		g_once_init_leave (&debug_domain_type_id__volatile, debug_domain_type_id);
	}
	return debug_domain_type_id__volatile;
}

void
debug_log (Debugdomain _domain,
           const gchar* reporter,
           const gchar* output)
{
	g_return_if_fail (reporter != NULL);
	if (haguichi_debugging) {
		GDateTime* now = NULL;
		GDateTime* _tmp0_;
		FILE* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GDateTime* _tmp4_;
		GDateTime* _tmp5_;
		GDateTime* _tmp6_;
		GDateTime* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		_tmp0_ = g_date_time_new_now_local ();
		now = _tmp0_;
		_tmp1_ = stdout;
		_tmp2_ = debug_domain_color (_domain);
		_tmp3_ = _tmp2_;
		_tmp4_ = now;
		_tmp5_ = now;
		_tmp6_ = now;
		_tmp7_ = now;
		_tmp8_ = debug_domain_name (_domain);
		_tmp9_ = _tmp8_;
		_tmp10_ = g_utf8_strup (_tmp9_, (gssize) -1);
		_tmp11_ = _tmp10_;
		fprintf (_tmp1_, "\x1b[%sm[%02d:%02d:%02d.%06d %s] [%s]\x1b[0m %s\n", _tmp3_, g_date_time_get_hour (_tmp4_), g_date_time_get_minute (_tmp5_), g_date_time_get_second (_tmp6_), g_date_time_get_microsecond (_tmp7_), _tmp11_, reporter, output);
		_g_free0 (_tmp11_);
		_g_free0 (_tmp9_);
		_g_free0 (_tmp3_);
		_g_date_time_unref0 (now);
	}
}

static gchar*
debug_domain_color (Debugdomain _domain)
{
	gchar* result = NULL;
	switch (_domain) {
		case DEBUG_DOMAIN_ERROR:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("00;31");
			result = _tmp0_;
			return result;
		}
		case DEBUG_DOMAIN_INFO:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("00;34");
			result = _tmp1_;
			return result;
		}
		case DEBUG_DOMAIN_HAMACHI:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("00;35");
			result = _tmp2_;
			return result;
		}
		case DEBUG_DOMAIN_ENVIRONMENT:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("00;36");
			result = _tmp3_;
			return result;
		}
		case DEBUG_DOMAIN_GUI:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("00;32");
			result = _tmp4_;
			return result;
		}
		default:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup ("0");
			result = _tmp5_;
			return result;
		}
	}
}

static gchar*
debug_domain_name (Debugdomain _domain)
{
	gchar* result = NULL;
	switch (_domain) {
		case DEBUG_DOMAIN_ERROR:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("Error");
			result = _tmp0_;
			return result;
		}
		case DEBUG_DOMAIN_INFO:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("Info");
			result = _tmp1_;
			return result;
		}
		case DEBUG_DOMAIN_HAMACHI:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("Hamachi");
			result = _tmp2_;
			return result;
		}
		case DEBUG_DOMAIN_ENVIRONMENT:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("Environment");
			result = _tmp3_;
			return result;
		}
		case DEBUG_DOMAIN_GUI:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("Gui");
			result = _tmp4_;
			return result;
		}
		default:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup ("Unknown");
			result = _tmp5_;
			return result;
		}
	}
}

Debug*
debug_construct (GType object_type)
{
	Debug * self = NULL;
	self = (Debug*) g_object_new (object_type, NULL);
	return self;
}

Debug*
debug_new (void)
{
	return debug_construct (TYPE_DEBUG);
}

static void
debug_class_init (DebugClass * klass,
                  gpointer klass_data)
{
	debug_parent_class = g_type_class_peek_parent (klass);
}

static void
debug_instance_init (Debug * self,
                     gpointer klass)
{
}

GType
debug_get_type (void)
{
	static volatile gsize debug_type_id__volatile = 0;
	if (g_once_init_enter (&debug_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DebugClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) debug_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Debug), 0, (GInstanceInitFunc) debug_instance_init, NULL };
		GType debug_type_id;
		debug_type_id = g_type_register_static (G_TYPE_OBJECT, "Debug", &g_define_type_info, 0);
		g_once_init_leave (&debug_type_id__volatile, debug_type_id);
	}
	return debug_type_id__volatile;
}

