/* base.c generated by valac 0.46.6, the Vala compiler
 * generated from base.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2018 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#define DIALOGS_TYPE_BASE (dialogs_base_get_type ())
#define DIALOGS_BASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIALOGS_TYPE_BASE, DialogsBase))
#define DIALOGS_BASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIALOGS_TYPE_BASE, DialogsBaseClass))
#define DIALOGS_IS_BASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIALOGS_TYPE_BASE))
#define DIALOGS_IS_BASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIALOGS_TYPE_BASE))
#define DIALOGS_BASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIALOGS_TYPE_BASE, DialogsBaseClass))

typedef struct _DialogsBase DialogsBase;
typedef struct _DialogsBaseClass DialogsBaseClass;
typedef struct _DialogsBasePrivate DialogsBasePrivate;
enum  {
	DIALOGS_BASE_0_PROPERTY,
	DIALOGS_BASE_NUM_PROPERTIES
};
static GParamSpec* dialogs_base_properties[DIALOGS_BASE_NUM_PROPERTIES];

#define TYPE_HAGUICHI_WINDOW (haguichi_window_get_type ())
#define HAGUICHI_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HAGUICHI_WINDOW, HaguichiWindow))
#define HAGUICHI_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HAGUICHI_WINDOW, HaguichiWindowClass))
#define IS_HAGUICHI_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HAGUICHI_WINDOW))
#define IS_HAGUICHI_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HAGUICHI_WINDOW))
#define HAGUICHI_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HAGUICHI_WINDOW, HaguichiWindowClass))

typedef struct _HaguichiWindow HaguichiWindow;
typedef struct _HaguichiWindowClass HaguichiWindowClass;

struct _DialogsBase {
	GtkMessageDialog parent_instance;
	DialogsBasePrivate * priv;
	gint response_id;
};

struct _DialogsBaseClass {
	GtkMessageDialogClass parent_class;
};

static gpointer dialogs_base_parent_class = NULL;
extern HaguichiWindow* haguichi_window;

GType dialogs_base_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DialogsBase, g_object_unref)
DialogsBase* dialogs_base_new (GtkWindow* parent,
                               const gchar* header_text,
                               const gchar* message_text,
                               GtkMessageType _message_type);
DialogsBase* dialogs_base_construct (GType object_type,
                                     GtkWindow* parent,
                                     const gchar* header_text,
                                     const gchar* message_text,
                                     GtkMessageType _message_type);
GType haguichi_window_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HaguichiWindow, g_object_unref)
void global_events_set_modal_dialog (GtkWindow* dialog);
void dialogs_base_on_response (DialogsBase* self,
                               GtkDialog* dialog,
                               gint _response_id);
static void _dialogs_base_on_response_gtk_dialog_response (GtkDialog* _sender,
                                                    gint response_id,
                                                    gpointer self);
void dialogs_base_add_content (DialogsBase* self,
                               GtkWidget* widget);
static void dialogs_base_finalize (GObject * obj);

static void
_dialogs_base_on_response_gtk_dialog_response (GtkDialog* _sender,
                                               gint response_id,
                                               gpointer self)
{
	dialogs_base_on_response ((DialogsBase*) self, _sender, response_id);
}

DialogsBase*
dialogs_base_construct (GType object_type,
                        GtkWindow* parent,
                        const gchar* header_text,
                        const gchar* message_text,
                        GtkMessageType _message_type)
{
	DialogsBase * self = NULL;
	GtkWindow* _tmp0_;
	GtkWindow* _tmp1_;
	HaguichiWindow* _tmp2_;
	g_return_val_if_fail (parent != NULL, NULL);
	g_return_val_if_fail (header_text != NULL, NULL);
	g_return_val_if_fail (message_text != NULL, NULL);
	self = (DialogsBase*) g_object_new (object_type, NULL);
	g_object_set ((GtkMessageDialog*) self, "text", header_text, NULL);
	g_object_set ((GtkMessageDialog*) self, "secondary-text", message_text, NULL);
	g_object_set ((GtkMessageDialog*) self, "message-type", _message_type, NULL);
	gtk_window_set_transient_for ((GtkWindow*) self, parent);
	_tmp0_ = gtk_window_get_transient_for ((GtkWindow*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = haguichi_window;
	if (_tmp1_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_window_get_type (), GtkWindow)) {
		global_events_set_modal_dialog ((GtkWindow*) self);
	}
	g_signal_connect_object ((GtkDialog*) self, "response", (GCallback) _dialogs_base_on_response_gtk_dialog_response, self, 0);
	return self;
}

DialogsBase*
dialogs_base_new (GtkWindow* parent,
                  const gchar* header_text,
                  const gchar* message_text,
                  GtkMessageType _message_type)
{
	return dialogs_base_construct (DIALOGS_TYPE_BASE, parent, header_text, message_text, _message_type);
}

void
dialogs_base_add_content (DialogsBase* self,
                          GtkWidget* widget)
{
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	_tmp0_ = gtk_message_dialog_get_message_area ((GtkMessageDialog*) self);
	_tmp1_ = _tmp0_;
	gtk_box_pack_end (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_box_get_type (), GtkBox), widget, FALSE, FALSE, (guint) 0);
	gtk_widget_show (widget);
}

void
dialogs_base_on_response (DialogsBase* self,
                          GtkDialog* dialog,
                          gint _response_id)
{
	GtkWindow* _tmp0_;
	GtkWindow* _tmp1_;
	HaguichiWindow* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (dialog != NULL);
	self->response_id = _response_id;
	_tmp0_ = gtk_window_get_transient_for ((GtkWindow*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = haguichi_window;
	if (_tmp1_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_window_get_type (), GtkWindow)) {
		global_events_set_modal_dialog (NULL);
	}
}

static void
dialogs_base_class_init (DialogsBaseClass * klass,
                         gpointer klass_data)
{
	dialogs_base_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = dialogs_base_finalize;
}

static void
dialogs_base_instance_init (DialogsBase * self,
                            gpointer klass)
{
}

static void
dialogs_base_finalize (GObject * obj)
{
	DialogsBase * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIALOGS_TYPE_BASE, DialogsBase);
	G_OBJECT_CLASS (dialogs_base_parent_class)->finalize (obj);
}

GType
dialogs_base_get_type (void)
{
	static volatile gsize dialogs_base_type_id__volatile = 0;
	if (g_once_init_enter (&dialogs_base_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DialogsBaseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dialogs_base_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DialogsBase), 0, (GInstanceInitFunc) dialogs_base_instance_init, NULL };
		GType dialogs_base_type_id;
		dialogs_base_type_id = g_type_register_static (gtk_message_dialog_get_type (), "DialogsBase", &g_define_type_info, 0);
		g_once_init_leave (&dialogs_base_type_id__volatile, dialogs_base_type_id);
	}
	return dialogs_base_type_id__volatile;
}

