/* headerbar.c generated by valac 0.46.6, the Vala compiler
 * generated from headerbar.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2018 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gdk/gdk.h>

#define TYPE_HEADERBAR (headerbar_get_type ())
#define HEADERBAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HEADERBAR, Headerbar))
#define HEADERBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HEADERBAR, HeaderbarClass))
#define IS_HEADERBAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HEADERBAR))
#define IS_HEADERBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HEADERBAR))
#define HEADERBAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HEADERBAR, HeaderbarClass))

typedef struct _Headerbar Headerbar;
typedef struct _HeaderbarClass HeaderbarClass;
typedef struct _HeaderbarPrivate HeaderbarPrivate;
enum  {
	HEADERBAR_0_PROPERTY,
	HEADERBAR_NUM_PROPERTIES
};
static GParamSpec* headerbar_properties[HEADERBAR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block20Data Block20Data;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _Headerbar {
	GtkHeaderBar parent_instance;
	HeaderbarPrivate * priv;
	GtkToggleButton* connect_but;
	GtkMenuButton* network_but;
	GtkMenuButton* client_but;
	GtkToggleButton* search_but;
	GtkButton* refresh_but;
	GtkMenuButton* gear_but;
	GtkBox* box;
};

struct _HeaderbarClass {
	GtkHeaderBarClass parent_class;
};

struct _HeaderbarPrivate {
	gchar* mode;
	gint minimum_width;
	gint last_allocated;
	gint connect_but_width;
	gint client_but_width;
	gint box_width;
	gint gear_but_width;
	gint search_but_width;
};

struct _Block20Data {
	int _ref_count_;
	Headerbar* self;
	GMenuItem* copy_ipv4;
	GMenuItem* copy_ipv6;
	GMenuItem* copy_id;
	GMenu* copy_section;
};

static gint Headerbar_private_offset;
static gpointer headerbar_parent_class = NULL;
extern gboolean haguichi_window_use_header_bar;
extern gchar* text_join_network_label;
extern gchar* text_create_network_label;
extern gchar* text_copy_address_ipv4_label;
extern gchar* text_copy_address_ipv6_label;
extern gchar* text_copy_client_id_label;
extern gchar* text_change_nick_label;
extern gchar* text_information_label;
extern gchar* text_config_folder_label;
extern gchar* text_config_save_label;
extern gchar* text_config_restore_label;
extern gchar* text_sort_by_name;
extern gchar* text_sort_by_status;
extern gchar* text_show_offline_members;
extern gchar* text_preferences_label;
extern gchar* text_donate_label;
extern gchar* text_shortcuts_label;
extern gchar* text_help_label;
extern gchar* text_about_label;
extern gchar* text_quit_label;
extern gchar* text_config_label;
extern gboolean haguichi_use_app_menu;
extern GtkAccelGroup* haguichi_window_accel_group;
extern gint haguichi_window_minimum_width;
extern GSimpleAction* global_actions_connect;
extern GSimpleAction* global_actions_disconnect;
extern GSimpleAction* global_actions_info;
extern GSimpleAction* global_actions_join_network;
extern GSimpleAction* global_actions_create_network;
extern GSimpleAction* global_actions_refresh;
extern GSimpleAction* global_actions_start_search;
extern GSimpleAction* global_actions_toggle_search;
extern gchar* text_initializing;
extern gint controller_restore_countdown;
extern gchar* text_connecting;
extern gchar* text_connected;
extern gchar* text_disconnected;

GType headerbar_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Headerbar, g_object_unref)
Headerbar* headerbar_new (void);
Headerbar* headerbar_construct (GType object_type);
static Block20Data* block20_data_ref (Block20Data* _data20_);
static void block20_data_unref (void * _userdata_);
static void __lambda4_ (Block20Data* _data20_);
gchar** hamachi_get_address (gint* result_length1);
gchar* hamachi_get_client_id (void);
static void ___lambda4__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                            gpointer self);
static GVariant* _variant_new3 (const gchar* value);
static GVariant* _variant_new4 (const gchar* value);
void headerbar_hide_all_buttons (Headerbar* self);
void headerbar_show_all_buttons (Headerbar* self);
void headerbar_show_hide_buttons (Headerbar* self,
                                  gint allocated,
                                  gint minimum);
static void headerbar_real_get_preferred_width (GtkWidget* base,
                                         gint* new_minimum_width,
                                         gint* new_natural_width);
void headerbar_set_mode (Headerbar* self,
                         const gchar* _mode);
gchar* utils_format (gchar* text,
                     const gchar* param1,
                     const gchar* param2,
                     const gchar* param3);
gchar* text_reconnecting (gint count);
void global_events_stop_search (void);
static void headerbar_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
headerbar_get_instance_private (Headerbar* self)
{
	return G_STRUCT_MEMBER_P (self, Headerbar_private_offset);
}

static Block20Data*
block20_data_ref (Block20Data* _data20_)
{
	g_atomic_int_inc (&_data20_->_ref_count_);
	return _data20_;
}

static void
block20_data_unref (void * _userdata_)
{
	Block20Data* _data20_;
	_data20_ = (Block20Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data20_->_ref_count_)) {
		Headerbar* self;
		self = _data20_->self;
		_g_object_unref0 (_data20_->copy_section);
		_g_object_unref0 (_data20_->copy_id);
		_g_object_unref0 (_data20_->copy_ipv6);
		_g_object_unref0 (_data20_->copy_ipv4);
		_g_object_unref0 (self);
		g_slice_free (Block20Data, _data20_);
	}
}

static void
__lambda4_ (Block20Data* _data20_)
{
	Headerbar* self;
	GtkMenuButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	self = _data20_->self;
	_tmp0_ = self->client_but;
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		gchar** address = NULL;
		gint _tmp3_ = 0;
		gchar** _tmp4_;
		gint address_length1;
		gint _address_size_;
		gchar* ipv4 = NULL;
		gchar** _tmp5_;
		gint _tmp5__length1;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* ipv6 = NULL;
		gchar** _tmp8_;
		gint _tmp8__length1;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		GMenu* _tmp11_;
		gboolean _tmp12_ = FALSE;
		const gchar* _tmp13_;
		const gchar* _tmp17_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gboolean _tmp22_;
		_tmp4_ = hamachi_get_address (&_tmp3_);
		address = _tmp4_;
		address_length1 = _tmp3_;
		_address_size_ = address_length1;
		_tmp5_ = address;
		_tmp5__length1 = address_length1;
		_tmp6_ = _tmp5_[0];
		_tmp7_ = g_strdup (_tmp6_);
		ipv4 = _tmp7_;
		_tmp8_ = address;
		_tmp8__length1 = address_length1;
		_tmp9_ = _tmp8_[1];
		_tmp10_ = g_strdup (_tmp9_);
		ipv6 = _tmp10_;
		_tmp11_ = _data20_->copy_section;
		g_menu_remove_all (_tmp11_);
		_tmp13_ = ipv4;
		if (_tmp13_ != NULL) {
			const gchar* _tmp14_;
			_tmp14_ = ipv4;
			_tmp12_ = g_strcmp0 (_tmp14_, "") != 0;
		} else {
			_tmp12_ = FALSE;
		}
		if (_tmp12_) {
			GMenu* _tmp15_;
			GMenuItem* _tmp16_;
			_tmp15_ = _data20_->copy_section;
			_tmp16_ = _data20_->copy_ipv4;
			g_menu_append_item (_tmp15_, _tmp16_);
		}
		_tmp17_ = ipv6;
		if (_tmp17_ != NULL) {
			GMenu* _tmp18_;
			GMenuItem* _tmp19_;
			_tmp18_ = _data20_->copy_section;
			_tmp19_ = _data20_->copy_ipv6;
			g_menu_append_item (_tmp18_, _tmp19_);
		}
		_tmp20_ = hamachi_get_client_id ();
		_tmp21_ = _tmp20_;
		_tmp22_ = g_strcmp0 (_tmp21_, "") != 0;
		_g_free0 (_tmp21_);
		if (_tmp22_) {
			GMenu* _tmp23_;
			GMenuItem* _tmp24_;
			_tmp23_ = _data20_->copy_section;
			_tmp24_ = _data20_->copy_id;
			g_menu_append_item (_tmp23_, _tmp24_);
		}
		_g_free0 (ipv6);
		_g_free0 (ipv4);
		address = (_vala_array_free (address, address_length1, (GDestroyNotify) g_free), NULL);
	}
}

static void
___lambda4__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                       gpointer self)
{
	__lambda4_ (self);
}

static GVariant*
_variant_new3 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static GVariant*
_variant_new4 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

Headerbar*
headerbar_construct (GType object_type)
{
	Headerbar * self = NULL;
	Block20Data* _data20_;
	GtkToggleButton* _tmp0_;
	GtkToggleButton* _tmp1_;
	GtkToggleButton* _tmp2_;
	GtkImage* _tmp3_;
	GtkImage* _tmp4_;
	GtkToggleButton* _tmp5_;
	GtkToggleButton* _tmp6_;
	GtkStyleContext* _tmp7_;
	GMenuItem* join = NULL;
	const gchar* _tmp8_;
	GMenuItem* _tmp9_;
	GMenuItem* create = NULL;
	const gchar* _tmp10_;
	GMenuItem* _tmp11_;
	GMenu* network_menu = NULL;
	GMenu* _tmp12_;
	GMenu* _tmp13_;
	GMenuItem* _tmp14_;
	GMenu* _tmp15_;
	GMenuItem* _tmp16_;
	GtkMenuButton* _tmp17_;
	GtkMenuButton* _tmp18_;
	GtkMenuButton* _tmp19_;
	GtkImage* _tmp20_;
	GtkImage* _tmp21_;
	GtkMenuButton* _tmp22_;
	GMenu* _tmp23_;
	const gchar* _tmp24_;
	GMenuItem* _tmp25_;
	const gchar* _tmp26_;
	GMenuItem* _tmp27_;
	const gchar* _tmp28_;
	GMenuItem* _tmp29_;
	GMenuItem* change_nick = NULL;
	const gchar* _tmp30_;
	GMenuItem* _tmp31_;
	GMenuItem* info = NULL;
	const gchar* _tmp32_;
	GMenuItem* _tmp33_;
	GMenu* info_section = NULL;
	GMenu* _tmp34_;
	GMenu* _tmp35_;
	GMenuItem* _tmp36_;
	GMenu* nick_section = NULL;
	GMenu* _tmp37_;
	GMenu* _tmp38_;
	GMenuItem* _tmp39_;
	GMenu* _tmp40_;
	GMenu* _tmp41_;
	GMenuItem* _tmp42_;
	GMenu* _tmp43_;
	GMenuItem* _tmp44_;
	GMenu* _tmp45_;
	GMenuItem* _tmp46_;
	GMenu* client_menu = NULL;
	GMenu* _tmp47_;
	GMenu* _tmp48_;
	GMenu* _tmp49_;
	GMenu* _tmp50_;
	GMenu* _tmp51_;
	GMenu* _tmp52_;
	GMenu* _tmp53_;
	GtkMenuButton* _tmp54_;
	GtkMenuButton* _tmp55_;
	GtkMenuButton* _tmp56_;
	GtkImage* _tmp57_;
	GtkImage* _tmp58_;
	GtkMenuButton* _tmp59_;
	GMenu* _tmp60_;
	GtkMenuButton* _tmp61_;
	GtkToggleButton* _tmp62_;
	GtkToggleButton* _tmp63_;
	GtkToggleButton* _tmp64_;
	GtkImage* _tmp65_;
	GtkImage* _tmp66_;
	GtkToggleButton* _tmp67_;
	GtkButton* _tmp68_;
	GtkButton* _tmp69_;
	GtkButton* _tmp70_;
	GtkImage* _tmp71_;
	GtkImage* _tmp72_;
	GtkButton* _tmp73_;
	GMenu* gear_menu = NULL;
	GMenu* _tmp74_;
	GMenuItem* open_config = NULL;
	const gchar* _tmp75_;
	GMenuItem* _tmp76_;
	GMenuItem* save_config = NULL;
	const gchar* _tmp77_;
	GMenuItem* _tmp78_;
	GMenuItem* restore_config = NULL;
	const gchar* _tmp79_;
	GMenuItem* _tmp80_;
	GMenuItem* sort_by_name = NULL;
	const gchar* _tmp81_;
	GMenuItem* _tmp82_;
	GMenuItem* _tmp83_;
	GVariant* _tmp84_;
	GMenuItem* sort_by_status = NULL;
	const gchar* _tmp85_;
	GMenuItem* _tmp86_;
	GMenuItem* _tmp87_;
	GVariant* _tmp88_;
	GMenuItem* show_offline = NULL;
	const gchar* _tmp89_;
	GMenuItem* _tmp90_;
	GMenuItem* preferences = NULL;
	const gchar* _tmp91_;
	GMenuItem* _tmp92_;
	GMenuItem* donate = NULL;
	const gchar* _tmp93_;
	GMenuItem* _tmp94_;
	GMenuItem* shortcuts = NULL;
	const gchar* _tmp95_;
	GMenuItem* _tmp96_;
	GMenuItem* help = NULL;
	const gchar* _tmp97_;
	GMenuItem* _tmp98_;
	GMenuItem* about = NULL;
	const gchar* _tmp99_;
	GMenuItem* _tmp100_;
	GMenuItem* quit = NULL;
	const gchar* _tmp101_;
	GMenuItem* _tmp102_;
	GMenu* backup_section = NULL;
	GMenu* _tmp103_;
	GMenu* _tmp104_;
	GMenuItem* _tmp105_;
	GMenu* _tmp106_;
	GMenuItem* _tmp107_;
	GMenu* config_submenu = NULL;
	GMenu* _tmp108_;
	GMenu* _tmp109_;
	GMenuItem* _tmp110_;
	GMenu* _tmp111_;
	GMenu* _tmp112_;
	GMenu* sort_section = NULL;
	GMenu* _tmp113_;
	GMenu* _tmp114_;
	GMenuItem* _tmp115_;
	GMenu* _tmp116_;
	GMenuItem* _tmp117_;
	GMenu* filter_section = NULL;
	GMenu* _tmp118_;
	GMenu* _tmp119_;
	GMenuItem* _tmp120_;
	GMenu* preferences_section = NULL;
	GMenu* _tmp121_;
	GMenu* _tmp122_;
	GMenuItem* _tmp123_;
	GMenu* donate_section = NULL;
	GMenu* _tmp124_;
	GMenu* _tmp125_;
	GMenuItem* _tmp126_;
	GMenu* meta_section = NULL;
	GMenu* _tmp127_;
	GMenu* _tmp128_;
	GMenuItem* _tmp129_;
	GMenu* _tmp130_;
	GMenuItem* _tmp131_;
	GMenu* _tmp132_;
	GMenuItem* _tmp133_;
	GMenu* _tmp134_;
	GMenuItem* _tmp135_;
	GMenu* _tmp136_;
	const gchar* _tmp137_;
	GMenu* _tmp138_;
	GMenu* _tmp139_;
	GMenu* _tmp140_;
	GMenu* _tmp141_;
	GMenu* _tmp142_;
	GtkMenuButton* _tmp149_;
	GtkMenuButton* _tmp150_;
	GtkMenuButton* _tmp151_;
	GtkImage* _tmp152_;
	GtkImage* _tmp153_;
	GtkMenuButton* _tmp154_;
	GMenu* _tmp155_;
	GtkMenuButton* _tmp156_;
	GtkAccelGroup* _tmp157_;
	GtkBox* _tmp158_;
	GtkBox* _tmp159_;
	GtkStyleContext* _tmp160_;
	GtkBox* _tmp161_;
	GtkMenuButton* _tmp162_;
	GtkBox* _tmp163_;
	GtkButton* _tmp164_;
	GtkToggleButton* _tmp165_;
	GtkMenuButton* _tmp166_;
	GtkBox* _tmp167_;
	GtkMenuButton* _tmp168_;
	GtkToggleButton* _tmp169_;
	GtkToggleButton* _tmp170_;
	gint _tmp171_ = 0;
	GtkMenuButton* _tmp172_;
	gint _tmp173_ = 0;
	GtkBox* _tmp174_;
	gint _tmp175_ = 0;
	GtkToggleButton* _tmp176_;
	gint _tmp177_ = 0;
	GtkMenuButton* _tmp178_;
	gint _tmp179_ = 0;
	gint _tmp180_ = 0;
	_data20_ = g_slice_new0 (Block20Data);
	_data20_->_ref_count_ = 1;
	self = (Headerbar*) g_object_new (object_type, NULL);
	_data20_->self = g_object_ref (self);
	gtk_header_bar_set_show_close_button ((GtkHeaderBar*) self, haguichi_window_use_header_bar);
	_tmp0_ = (GtkToggleButton*) gtk_toggle_button_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->connect_but);
	self->connect_but = _tmp0_;
	_tmp1_ = self->connect_but;
	gtk_widget_set_valign ((GtkWidget*) _tmp1_, GTK_ALIGN_CENTER);
	_tmp2_ = self->connect_but;
	_tmp3_ = (GtkImage*) gtk_image_new_from_icon_name ("system-shutdown-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp3_);
	_tmp4_ = _tmp3_;
	gtk_button_set_image ((GtkButton*) _tmp2_, (GtkWidget*) _tmp4_);
	_g_object_unref0 (_tmp4_);
	_tmp5_ = self->connect_but;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp5_, "app.connect");
	_tmp6_ = self->connect_but;
	_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) _tmp6_);
	gtk_style_context_add_class (_tmp7_, "suggested-action");
	_tmp8_ = text_join_network_label;
	_tmp9_ = g_menu_item_new (_tmp8_, "app.join-network");
	join = _tmp9_;
	_tmp10_ = text_create_network_label;
	_tmp11_ = g_menu_item_new (_tmp10_, "app.create-network");
	create = _tmp11_;
	_tmp12_ = g_menu_new ();
	network_menu = _tmp12_;
	_tmp13_ = network_menu;
	_tmp14_ = join;
	g_menu_append_item (_tmp13_, _tmp14_);
	_tmp15_ = network_menu;
	_tmp16_ = create;
	g_menu_append_item (_tmp15_, _tmp16_);
	_tmp17_ = (GtkMenuButton*) gtk_menu_button_new ();
	g_object_ref_sink (_tmp17_);
	_g_object_unref0 (self->network_but);
	self->network_but = _tmp17_;
	_tmp18_ = self->network_but;
	gtk_widget_set_valign ((GtkWidget*) _tmp18_, GTK_ALIGN_CENTER);
	_tmp19_ = self->network_but;
	_tmp20_ = (GtkImage*) gtk_image_new_from_icon_name ("list-add-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp20_);
	_tmp21_ = _tmp20_;
	gtk_button_set_image ((GtkButton*) _tmp19_, (GtkWidget*) _tmp21_);
	_g_object_unref0 (_tmp21_);
	_tmp22_ = self->network_but;
	_tmp23_ = network_menu;
	gtk_menu_button_set_menu_model (_tmp22_, (GMenuModel*) _tmp23_);
	_tmp24_ = text_copy_address_ipv4_label;
	_tmp25_ = g_menu_item_new (_tmp24_, "app.copy-ipv4");
	_data20_->copy_ipv4 = _tmp25_;
	_tmp26_ = text_copy_address_ipv6_label;
	_tmp27_ = g_menu_item_new (_tmp26_, "app.copy-ipv6");
	_data20_->copy_ipv6 = _tmp27_;
	_tmp28_ = text_copy_client_id_label;
	_tmp29_ = g_menu_item_new (_tmp28_, "app.copy-id");
	_data20_->copy_id = _tmp29_;
	_tmp30_ = text_change_nick_label;
	_tmp31_ = g_menu_item_new (_tmp30_, "app.change-nick");
	change_nick = _tmp31_;
	_tmp32_ = text_information_label;
	_tmp33_ = g_menu_item_new (_tmp32_, "app.info");
	info = _tmp33_;
	_tmp34_ = g_menu_new ();
	info_section = _tmp34_;
	_tmp35_ = info_section;
	_tmp36_ = info;
	g_menu_append_item (_tmp35_, _tmp36_);
	_tmp37_ = g_menu_new ();
	nick_section = _tmp37_;
	_tmp38_ = nick_section;
	_tmp39_ = change_nick;
	g_menu_append_item (_tmp38_, _tmp39_);
	_tmp40_ = g_menu_new ();
	_data20_->copy_section = _tmp40_;
	_tmp41_ = _data20_->copy_section;
	_tmp42_ = _data20_->copy_ipv4;
	g_menu_append_item (_tmp41_, _tmp42_);
	_tmp43_ = _data20_->copy_section;
	_tmp44_ = _data20_->copy_ipv6;
	g_menu_append_item (_tmp43_, _tmp44_);
	_tmp45_ = _data20_->copy_section;
	_tmp46_ = _data20_->copy_id;
	g_menu_append_item (_tmp45_, _tmp46_);
	_tmp47_ = g_menu_new ();
	client_menu = _tmp47_;
	_tmp48_ = client_menu;
	_tmp49_ = info_section;
	g_menu_append_section (_tmp48_, NULL, (GMenuModel*) _tmp49_);
	_tmp50_ = client_menu;
	_tmp51_ = nick_section;
	g_menu_append_section (_tmp50_, NULL, (GMenuModel*) _tmp51_);
	_tmp52_ = client_menu;
	_tmp53_ = _data20_->copy_section;
	g_menu_append_section (_tmp52_, NULL, (GMenuModel*) _tmp53_);
	_tmp54_ = (GtkMenuButton*) gtk_menu_button_new ();
	g_object_ref_sink (_tmp54_);
	_g_object_unref0 (self->client_but);
	self->client_but = _tmp54_;
	_tmp55_ = self->client_but;
	gtk_widget_set_valign ((GtkWidget*) _tmp55_, GTK_ALIGN_CENTER);
	_tmp56_ = self->client_but;
	_tmp57_ = (GtkImage*) gtk_image_new_from_icon_name ("avatar-default-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp57_);
	_tmp58_ = _tmp57_;
	gtk_button_set_image ((GtkButton*) _tmp56_, (GtkWidget*) _tmp58_);
	_g_object_unref0 (_tmp58_);
	_tmp59_ = self->client_but;
	_tmp60_ = client_menu;
	gtk_menu_button_set_menu_model (_tmp59_, (GMenuModel*) _tmp60_);
	_tmp61_ = self->client_but;
	g_signal_connect_data ((GtkToggleButton*) _tmp61_, "toggled", (GCallback) ___lambda4__gtk_toggle_button_toggled, block20_data_ref (_data20_), (GClosureNotify) block20_data_unref, 0);
	_tmp62_ = (GtkToggleButton*) gtk_toggle_button_new ();
	g_object_ref_sink (_tmp62_);
	_g_object_unref0 (self->search_but);
	self->search_but = _tmp62_;
	_tmp63_ = self->search_but;
	gtk_widget_set_valign ((GtkWidget*) _tmp63_, GTK_ALIGN_CENTER);
	_tmp64_ = self->search_but;
	_tmp65_ = (GtkImage*) gtk_image_new_from_icon_name ("edit-find-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp65_);
	_tmp66_ = _tmp65_;
	gtk_button_set_image ((GtkButton*) _tmp64_, (GtkWidget*) _tmp66_);
	_g_object_unref0 (_tmp66_);
	_tmp67_ = self->search_but;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp67_, "app.toggle-search");
	_tmp68_ = (GtkButton*) gtk_button_new ();
	g_object_ref_sink (_tmp68_);
	_g_object_unref0 (self->refresh_but);
	self->refresh_but = _tmp68_;
	_tmp69_ = self->refresh_but;
	gtk_widget_set_valign ((GtkWidget*) _tmp69_, GTK_ALIGN_CENTER);
	_tmp70_ = self->refresh_but;
	_tmp71_ = (GtkImage*) gtk_image_new_from_icon_name ("view-refresh-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp71_);
	_tmp72_ = _tmp71_;
	gtk_button_set_image (_tmp70_, (GtkWidget*) _tmp72_);
	_g_object_unref0 (_tmp72_);
	_tmp73_ = self->refresh_but;
	gtk_actionable_set_action_name ((GtkActionable*) _tmp73_, "app.refresh");
	_tmp74_ = g_menu_new ();
	gear_menu = _tmp74_;
	_tmp75_ = text_config_folder_label;
	_tmp76_ = g_menu_item_new (_tmp75_, "app.open-config");
	open_config = _tmp76_;
	_tmp77_ = text_config_save_label;
	_tmp78_ = g_menu_item_new (_tmp77_, "app.save-config");
	save_config = _tmp78_;
	_tmp79_ = text_config_restore_label;
	_tmp80_ = g_menu_item_new (_tmp79_, "app.restore-config");
	restore_config = _tmp80_;
	_tmp81_ = text_sort_by_name;
	_tmp82_ = g_menu_item_new (_tmp81_, "app.sort-by");
	sort_by_name = _tmp82_;
	_tmp83_ = sort_by_name;
	_tmp84_ = _variant_new3 ("name");
	g_menu_item_set_attribute_value (_tmp83_, "target", _tmp84_);
	_g_variant_unref0 (_tmp84_);
	_tmp85_ = text_sort_by_status;
	_tmp86_ = g_menu_item_new (_tmp85_, "app.sort-by");
	sort_by_status = _tmp86_;
	_tmp87_ = sort_by_status;
	_tmp88_ = _variant_new4 ("status");
	g_menu_item_set_attribute_value (_tmp87_, "target", _tmp88_);
	_g_variant_unref0 (_tmp88_);
	_tmp89_ = text_show_offline_members;
	_tmp90_ = g_menu_item_new (_tmp89_, "app.show-offline-members");
	show_offline = _tmp90_;
	_tmp91_ = text_preferences_label;
	_tmp92_ = g_menu_item_new (_tmp91_, "app.preferences");
	preferences = _tmp92_;
	_tmp93_ = text_donate_label;
	_tmp94_ = g_menu_item_new (_tmp93_, "app.donate");
	donate = _tmp94_;
	_tmp95_ = text_shortcuts_label;
	_tmp96_ = g_menu_item_new (_tmp95_, "app.shortcuts");
	shortcuts = _tmp96_;
	_tmp97_ = text_help_label;
	_tmp98_ = g_menu_item_new (_tmp97_, "app.help");
	help = _tmp98_;
	_tmp99_ = text_about_label;
	_tmp100_ = g_menu_item_new (_tmp99_, "app.about");
	about = _tmp100_;
	_tmp101_ = text_quit_label;
	_tmp102_ = g_menu_item_new (_tmp101_, "app.quit");
	quit = _tmp102_;
	_tmp103_ = g_menu_new ();
	backup_section = _tmp103_;
	_tmp104_ = backup_section;
	_tmp105_ = save_config;
	g_menu_append_item (_tmp104_, _tmp105_);
	_tmp106_ = backup_section;
	_tmp107_ = restore_config;
	g_menu_append_item (_tmp106_, _tmp107_);
	_tmp108_ = g_menu_new ();
	config_submenu = _tmp108_;
	_tmp109_ = config_submenu;
	_tmp110_ = open_config;
	g_menu_append_item (_tmp109_, _tmp110_);
	_tmp111_ = config_submenu;
	_tmp112_ = backup_section;
	g_menu_append_section (_tmp111_, NULL, (GMenuModel*) _tmp112_);
	_tmp113_ = g_menu_new ();
	sort_section = _tmp113_;
	_tmp114_ = sort_section;
	_tmp115_ = sort_by_name;
	g_menu_append_item (_tmp114_, _tmp115_);
	_tmp116_ = sort_section;
	_tmp117_ = sort_by_status;
	g_menu_append_item (_tmp116_, _tmp117_);
	_tmp118_ = g_menu_new ();
	filter_section = _tmp118_;
	_tmp119_ = filter_section;
	_tmp120_ = show_offline;
	g_menu_append_item (_tmp119_, _tmp120_);
	_tmp121_ = g_menu_new ();
	preferences_section = _tmp121_;
	_tmp122_ = preferences_section;
	_tmp123_ = preferences;
	g_menu_append_item (_tmp122_, _tmp123_);
	_tmp124_ = g_menu_new ();
	donate_section = _tmp124_;
	_tmp125_ = donate_section;
	_tmp126_ = donate;
	g_menu_append_item (_tmp125_, _tmp126_);
	_tmp127_ = g_menu_new ();
	meta_section = _tmp127_;
	_tmp128_ = meta_section;
	_tmp129_ = shortcuts;
	g_menu_append_item (_tmp128_, _tmp129_);
	_tmp130_ = meta_section;
	_tmp131_ = help;
	g_menu_append_item (_tmp130_, _tmp131_);
	_tmp132_ = meta_section;
	_tmp133_ = about;
	g_menu_append_item (_tmp132_, _tmp133_);
	_tmp134_ = meta_section;
	_tmp135_ = quit;
	g_menu_append_item (_tmp134_, _tmp135_);
	_tmp136_ = gear_menu;
	_tmp137_ = text_config_label;
	_tmp138_ = config_submenu;
	g_menu_append_submenu (_tmp136_, _tmp137_, (GMenuModel*) _tmp138_);
	_tmp139_ = gear_menu;
	_tmp140_ = sort_section;
	g_menu_append_section (_tmp139_, NULL, (GMenuModel*) _tmp140_);
	_tmp141_ = gear_menu;
	_tmp142_ = filter_section;
	g_menu_append_section (_tmp141_, NULL, (GMenuModel*) _tmp142_);
	if (!haguichi_use_app_menu) {
		GMenu* _tmp143_;
		GMenu* _tmp144_;
		GMenu* _tmp145_;
		GMenu* _tmp146_;
		GMenu* _tmp147_;
		GMenu* _tmp148_;
		_tmp143_ = gear_menu;
		_tmp144_ = preferences_section;
		g_menu_append_section (_tmp143_, NULL, (GMenuModel*) _tmp144_);
		_tmp145_ = gear_menu;
		_tmp146_ = donate_section;
		g_menu_append_section (_tmp145_, NULL, (GMenuModel*) _tmp146_);
		_tmp147_ = gear_menu;
		_tmp148_ = meta_section;
		g_menu_append_section (_tmp147_, NULL, (GMenuModel*) _tmp148_);
	}
	_tmp149_ = (GtkMenuButton*) gtk_menu_button_new ();
	g_object_ref_sink (_tmp149_);
	_g_object_unref0 (self->gear_but);
	self->gear_but = _tmp149_;
	_tmp150_ = self->gear_but;
	gtk_widget_set_valign ((GtkWidget*) _tmp150_, GTK_ALIGN_CENTER);
	_tmp151_ = self->gear_but;
	_tmp152_ = (GtkImage*) gtk_image_new_from_icon_name ("open-menu-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp152_);
	_tmp153_ = _tmp152_;
	gtk_button_set_image ((GtkButton*) _tmp151_, (GtkWidget*) _tmp153_);
	_g_object_unref0 (_tmp153_);
	_tmp154_ = self->gear_but;
	_tmp155_ = gear_menu;
	gtk_menu_button_set_menu_model (_tmp154_, (GMenuModel*) _tmp155_);
	_tmp156_ = self->gear_but;
	_tmp157_ = haguichi_window_accel_group;
	gtk_widget_add_accelerator ((GtkWidget*) _tmp156_, "clicked", _tmp157_, GDK_KEY_F10, 0, GTK_ACCEL_VISIBLE);
	_tmp158_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
	g_object_ref_sink (_tmp158_);
	_g_object_unref0 (self->box);
	self->box = _tmp158_;
	_tmp159_ = self->box;
	_tmp160_ = gtk_widget_get_style_context ((GtkWidget*) _tmp159_);
	gtk_style_context_add_class (_tmp160_, "linked");
	_tmp161_ = self->box;
	_tmp162_ = self->network_but;
	gtk_container_add ((GtkContainer*) _tmp161_, (GtkWidget*) _tmp162_);
	_tmp163_ = self->box;
	_tmp164_ = self->refresh_but;
	gtk_container_add ((GtkContainer*) _tmp163_, (GtkWidget*) _tmp164_);
	_tmp165_ = self->connect_but;
	gtk_header_bar_pack_start ((GtkHeaderBar*) self, (GtkWidget*) _tmp165_);
	_tmp166_ = self->client_but;
	gtk_header_bar_pack_start ((GtkHeaderBar*) self, (GtkWidget*) _tmp166_);
	_tmp167_ = self->box;
	gtk_header_bar_pack_start ((GtkHeaderBar*) self, (GtkWidget*) _tmp167_);
	_tmp168_ = self->gear_but;
	gtk_header_bar_pack_end ((GtkHeaderBar*) self, (GtkWidget*) _tmp168_);
	_tmp169_ = self->search_but;
	gtk_header_bar_pack_end ((GtkHeaderBar*) self, (GtkWidget*) _tmp169_);
	gtk_widget_show_all ((GtkWidget*) self);
	_tmp170_ = self->connect_but;
	gtk_widget_get_preferred_width ((GtkWidget*) _tmp170_, &_tmp171_, NULL);
	self->priv->connect_but_width = _tmp171_;
	_tmp172_ = self->client_but;
	gtk_widget_get_preferred_width ((GtkWidget*) _tmp172_, &_tmp173_, NULL);
	self->priv->client_but_width = _tmp173_;
	_tmp174_ = self->box;
	gtk_widget_get_preferred_width ((GtkWidget*) _tmp174_, &_tmp175_, NULL);
	self->priv->box_width = _tmp175_;
	_tmp176_ = self->search_but;
	gtk_widget_get_preferred_width ((GtkWidget*) _tmp176_, &_tmp177_, NULL);
	self->priv->search_but_width = _tmp177_;
	_tmp178_ = self->gear_but;
	gtk_widget_get_preferred_width ((GtkWidget*) _tmp178_, &_tmp179_, NULL);
	self->priv->gear_but_width = _tmp179_;
	headerbar_hide_all_buttons (self);
	gtk_widget_get_preferred_width ((GtkWidget*) self, &_tmp180_, NULL);
	self->priv->minimum_width = _tmp180_;
	_g_object_unref0 (meta_section);
	_g_object_unref0 (donate_section);
	_g_object_unref0 (preferences_section);
	_g_object_unref0 (filter_section);
	_g_object_unref0 (sort_section);
	_g_object_unref0 (config_submenu);
	_g_object_unref0 (backup_section);
	_g_object_unref0 (quit);
	_g_object_unref0 (about);
	_g_object_unref0 (help);
	_g_object_unref0 (shortcuts);
	_g_object_unref0 (donate);
	_g_object_unref0 (preferences);
	_g_object_unref0 (show_offline);
	_g_object_unref0 (sort_by_status);
	_g_object_unref0 (sort_by_name);
	_g_object_unref0 (restore_config);
	_g_object_unref0 (save_config);
	_g_object_unref0 (open_config);
	_g_object_unref0 (gear_menu);
	_g_object_unref0 (client_menu);
	_g_object_unref0 (nick_section);
	_g_object_unref0 (info_section);
	_g_object_unref0 (info);
	_g_object_unref0 (change_nick);
	_g_object_unref0 (network_menu);
	_g_object_unref0 (create);
	_g_object_unref0 (join);
	block20_data_unref (_data20_);
	_data20_ = NULL;
	return self;
}

Headerbar*
headerbar_new (void)
{
	return headerbar_construct (TYPE_HEADERBAR);
}

void
headerbar_show_all_buttons (Headerbar* self)
{
	GtkToggleButton* _tmp0_;
	GtkMenuButton* _tmp1_;
	GtkBox* _tmp2_;
	GtkToggleButton* _tmp3_;
	GtkMenuButton* _tmp4_;
	g_return_if_fail (self != NULL);
	self->priv->last_allocated = 0;
	_tmp0_ = self->connect_but;
	gtk_widget_show ((GtkWidget*) _tmp0_);
	_tmp1_ = self->client_but;
	gtk_widget_show ((GtkWidget*) _tmp1_);
	_tmp2_ = self->box;
	gtk_widget_show ((GtkWidget*) _tmp2_);
	_tmp3_ = self->search_but;
	gtk_widget_show ((GtkWidget*) _tmp3_);
	_tmp4_ = self->gear_but;
	gtk_widget_show ((GtkWidget*) _tmp4_);
}

void
headerbar_hide_all_buttons (Headerbar* self)
{
	GtkToggleButton* _tmp0_;
	GtkMenuButton* _tmp1_;
	GtkBox* _tmp2_;
	GtkToggleButton* _tmp3_;
	GtkMenuButton* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->connect_but;
	gtk_widget_hide ((GtkWidget*) _tmp0_);
	_tmp1_ = self->client_but;
	gtk_widget_hide ((GtkWidget*) _tmp1_);
	_tmp2_ = self->box;
	gtk_widget_hide ((GtkWidget*) _tmp2_);
	_tmp3_ = self->search_but;
	gtk_widget_hide ((GtkWidget*) _tmp3_);
	_tmp4_ = self->gear_but;
	gtk_widget_hide ((GtkWidget*) _tmp4_);
}

void
headerbar_show_hide_buttons (Headerbar* self,
                             gint allocated,
                             gint minimum)
{
	gint current = 0;
	GtkToggleButton* _tmp0_;
	g_return_if_fail (self != NULL);
	if (allocated == self->priv->last_allocated) {
		return;
	}
	self->priv->last_allocated = allocated;
	headerbar_hide_all_buttons (self);
	current = minimum + self->priv->connect_but_width;
	_tmp0_ = self->connect_but;
	gtk_widget_show ((GtkWidget*) _tmp0_);
	current += self->priv->gear_but_width;
	if (allocated > current) {
		GtkMenuButton* _tmp1_;
		_tmp1_ = self->gear_but;
		gtk_widget_show ((GtkWidget*) _tmp1_);
	}
	current += self->priv->client_but_width;
	if (allocated > current) {
		GtkMenuButton* _tmp2_;
		_tmp2_ = self->client_but;
		gtk_widget_show ((GtkWidget*) _tmp2_);
	}
	current += self->priv->search_but_width;
	if (allocated > current) {
		GtkToggleButton* _tmp3_;
		_tmp3_ = self->search_but;
		gtk_widget_show ((GtkWidget*) _tmp3_);
	}
	current += self->priv->box_width;
	if (allocated > current) {
		GtkBox* _tmp4_;
		_tmp4_ = self->box;
		gtk_widget_show ((GtkWidget*) _tmp4_);
	}
}

static void
headerbar_real_get_preferred_width (GtkWidget* base,
                                    gint* new_minimum_width,
                                    gint* new_natural_width)
{
	Headerbar * self;
	gint _vala_new_minimum_width = 0;
	gint _vala_new_natural_width = 0;
	gboolean _tmp0_ = FALSE;
	self = (Headerbar*) base;
	if (haguichi_window_use_header_bar == FALSE) {
		_tmp0_ = self->priv->minimum_width > 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
	} else {
		if (haguichi_window_minimum_width > 0) {
			const gchar* _tmp1_;
			self->priv->minimum_width = haguichi_window_minimum_width;
			_tmp1_ = gtk_check_version ((guint) 3, (guint) 18, (guint) 0);
			if (_tmp1_ == NULL) {
				self->priv->minimum_width = self->priv->minimum_width + 50;
			}
		} else {
			gint base_minimum_width = 0;
			gint base_natural_width = 0;
			gint _tmp2_ = 0;
			gint _tmp3_ = 0;
			GTK_WIDGET_CLASS (headerbar_parent_class)->get_preferred_width ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_header_bar_get_type (), GtkHeaderBar), &_tmp2_, &_tmp3_);
			base_minimum_width = _tmp2_;
			base_natural_width = _tmp3_;
			self->priv->minimum_width = base_minimum_width;
		}
	}
	_vala_new_minimum_width = self->priv->minimum_width;
	_vala_new_natural_width = self->priv->minimum_width;
	if (new_minimum_width) {
		*new_minimum_width = _vala_new_minimum_width;
	}
	if (new_natural_width) {
		*new_natural_width = _vala_new_natural_width;
	}
}

void
headerbar_set_mode (Headerbar* self,
                    const gchar* _mode)
{
	gchar* _tmp0_;
	GSimpleAction* _tmp1_;
	GSimpleAction* _tmp2_;
	GSimpleAction* _tmp3_;
	GSimpleAction* _tmp4_;
	GSimpleAction* _tmp5_;
	GSimpleAction* _tmp6_;
	GSimpleAction* _tmp7_;
	GSimpleAction* _tmp8_;
	GtkMenuButton* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	GQuark _tmp13_ = 0U;
	static GQuark _tmp12_label0 = 0;
	static GQuark _tmp12_label1 = 0;
	static GQuark _tmp12_label2 = 0;
	static GQuark _tmp12_label3 = 0;
	static GQuark _tmp12_label4 = 0;
	static GQuark _tmp12_label5 = 0;
	static GQuark _tmp12_label6 = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_mode != NULL);
	_tmp0_ = g_strdup (_mode);
	_g_free0 (self->priv->mode);
	self->priv->mode = _tmp0_;
	_tmp1_ = global_actions_connect;
	g_simple_action_set_enabled (_tmp1_, FALSE);
	_tmp2_ = global_actions_disconnect;
	g_simple_action_set_enabled (_tmp2_, FALSE);
	_tmp3_ = global_actions_info;
	g_simple_action_set_enabled (_tmp3_, FALSE);
	_tmp4_ = global_actions_join_network;
	g_simple_action_set_enabled (_tmp4_, FALSE);
	_tmp5_ = global_actions_create_network;
	g_simple_action_set_enabled (_tmp5_, FALSE);
	_tmp6_ = global_actions_refresh;
	g_simple_action_set_enabled (_tmp6_, FALSE);
	_tmp7_ = global_actions_start_search;
	g_simple_action_set_enabled (_tmp7_, FALSE);
	_tmp8_ = global_actions_toggle_search;
	g_simple_action_set_enabled (_tmp8_, FALSE);
	_tmp9_ = self->network_but;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, FALSE);
	_tmp10_ = self->priv->mode;
	_tmp11_ = _tmp10_;
	_tmp13_ = (NULL == _tmp11_) ? 0 : g_quark_from_string (_tmp11_);
	if (_tmp13_ == ((0 != _tmp12_label0) ? _tmp12_label0 : (_tmp12_label0 = g_quark_from_static_string ("Initializing")))) {
		switch (0) {
			default:
			{
				const gchar* _tmp14_;
				_tmp14_ = text_initializing;
				gtk_header_bar_set_subtitle ((GtkHeaderBar*) self, _tmp14_);
				break;
			}
		}
	} else if (_tmp13_ == ((0 != _tmp12_label1) ? _tmp12_label1 : (_tmp12_label1 = g_quark_from_static_string ("Countdown")))) {
		switch (0) {
			default:
			{
				GSimpleAction* _tmp15_;
				GSimpleAction* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
				gchar* _tmp21_;
				_tmp15_ = global_actions_connect;
				g_simple_action_set_enabled (_tmp15_, TRUE);
				_tmp16_ = global_actions_info;
				g_simple_action_set_enabled (_tmp16_, TRUE);
				_tmp17_ = text_reconnecting (controller_restore_countdown);
				_tmp18_ = g_strdup_printf ("%i", controller_restore_countdown);
				_tmp19_ = _tmp18_;
				_tmp20_ = utils_format (_tmp17_, _tmp19_, NULL, NULL);
				_tmp21_ = _tmp20_;
				gtk_header_bar_set_subtitle ((GtkHeaderBar*) self, _tmp21_);
				_g_free0 (_tmp21_);
				_g_free0 (_tmp19_);
				break;
			}
		}
	} else if (_tmp13_ == ((0 != _tmp12_label2) ? _tmp12_label2 : (_tmp12_label2 = g_quark_from_static_string ("Connecting")))) {
		switch (0) {
			default:
			{
				GtkToggleButton* _tmp22_;
				GSimpleAction* _tmp23_;
				const gchar* _tmp24_;
				_tmp22_ = self->connect_but;
				gtk_toggle_button_set_active (_tmp22_, TRUE);
				_tmp23_ = global_actions_info;
				g_simple_action_set_enabled (_tmp23_, TRUE);
				_tmp24_ = text_connecting;
				gtk_header_bar_set_subtitle ((GtkHeaderBar*) self, _tmp24_);
				break;
			}
		}
	} else if (_tmp13_ == ((0 != _tmp12_label3) ? _tmp12_label3 : (_tmp12_label3 = g_quark_from_static_string ("Connected")))) {
		switch (0) {
			default:
			{
				GtkToggleButton* _tmp25_;
				GtkToggleButton* _tmp26_;
				GSimpleAction* _tmp27_;
				GSimpleAction* _tmp28_;
				GSimpleAction* _tmp29_;
				GSimpleAction* _tmp30_;
				GSimpleAction* _tmp31_;
				GSimpleAction* _tmp32_;
				GSimpleAction* _tmp33_;
				GtkMenuButton* _tmp34_;
				const gchar* _tmp35_;
				_tmp25_ = self->connect_but;
				gtk_actionable_set_action_name ((GtkActionable*) _tmp25_, "app.disconnect");
				_tmp26_ = self->connect_but;
				gtk_toggle_button_set_active (_tmp26_, TRUE);
				_tmp27_ = global_actions_disconnect;
				g_simple_action_set_enabled (_tmp27_, TRUE);
				_tmp28_ = global_actions_info;
				g_simple_action_set_enabled (_tmp28_, TRUE);
				_tmp29_ = global_actions_join_network;
				g_simple_action_set_enabled (_tmp29_, TRUE);
				_tmp30_ = global_actions_create_network;
				g_simple_action_set_enabled (_tmp30_, TRUE);
				_tmp31_ = global_actions_refresh;
				g_simple_action_set_enabled (_tmp31_, TRUE);
				_tmp32_ = global_actions_start_search;
				g_simple_action_set_enabled (_tmp32_, TRUE);
				_tmp33_ = global_actions_toggle_search;
				g_simple_action_set_enabled (_tmp33_, TRUE);
				_tmp34_ = self->network_but;
				gtk_widget_set_sensitive ((GtkWidget*) _tmp34_, TRUE);
				_tmp35_ = text_connected;
				gtk_header_bar_set_subtitle ((GtkHeaderBar*) self, _tmp35_);
				break;
			}
		}
	} else if (_tmp13_ == ((0 != _tmp12_label4) ? _tmp12_label4 : (_tmp12_label4 = g_quark_from_static_string ("Disconnected")))) {
		switch (0) {
			default:
			{
				GtkToggleButton* _tmp36_;
				GtkToggleButton* _tmp37_;
				GSimpleAction* _tmp38_;
				GSimpleAction* _tmp39_;
				const gchar* _tmp40_;
				_tmp36_ = self->connect_but;
				gtk_actionable_set_action_name ((GtkActionable*) _tmp36_, "app.connect");
				_tmp37_ = self->connect_but;
				gtk_toggle_button_set_active (_tmp37_, FALSE);
				_tmp38_ = global_actions_connect;
				g_simple_action_set_enabled (_tmp38_, TRUE);
				_tmp39_ = global_actions_info;
				g_simple_action_set_enabled (_tmp39_, TRUE);
				global_events_stop_search ();
				_tmp40_ = text_disconnected;
				gtk_header_bar_set_subtitle ((GtkHeaderBar*) self, _tmp40_);
				break;
			}
		}
	} else if (_tmp13_ == ((0 != _tmp12_label5) ? _tmp12_label5 : (_tmp12_label5 = g_quark_from_static_string ("Not configured")))) {
		switch (0) {
			default:
			{
				GtkToggleButton* _tmp41_;
				GSimpleAction* _tmp42_;
				const gchar* _tmp43_;
				_tmp41_ = self->connect_but;
				gtk_toggle_button_set_active (_tmp41_, FALSE);
				_tmp42_ = global_actions_refresh;
				g_simple_action_set_enabled (_tmp42_, TRUE);
				_tmp43_ = text_disconnected;
				gtk_header_bar_set_subtitle ((GtkHeaderBar*) self, _tmp43_);
				break;
			}
		}
	} else if (_tmp13_ == ((0 != _tmp12_label6) ? _tmp12_label6 : (_tmp12_label6 = g_quark_from_static_string ("Not installed")))) {
		switch (0) {
			default:
			{
				GtkToggleButton* _tmp44_;
				GSimpleAction* _tmp45_;
				const gchar* _tmp46_;
				_tmp44_ = self->connect_but;
				gtk_toggle_button_set_active (_tmp44_, FALSE);
				_tmp45_ = global_actions_refresh;
				g_simple_action_set_enabled (_tmp45_, TRUE);
				_tmp46_ = text_disconnected;
				gtk_header_bar_set_subtitle ((GtkHeaderBar*) self, _tmp46_);
				break;
			}
		}
	}
}

static void
headerbar_class_init (HeaderbarClass * klass,
                      gpointer klass_data)
{
	headerbar_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Headerbar_private_offset);
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget*, gint*, gint*)) headerbar_real_get_preferred_width;
	G_OBJECT_CLASS (klass)->finalize = headerbar_finalize;
}

static void
headerbar_instance_init (Headerbar * self,
                         gpointer klass)
{
	self->priv = headerbar_get_instance_private (self);
}

static void
headerbar_finalize (GObject * obj)
{
	Headerbar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HEADERBAR, Headerbar);
	_g_free0 (self->priv->mode);
	_g_object_unref0 (self->connect_but);
	_g_object_unref0 (self->network_but);
	_g_object_unref0 (self->client_but);
	_g_object_unref0 (self->search_but);
	_g_object_unref0 (self->refresh_but);
	_g_object_unref0 (self->gear_but);
	_g_object_unref0 (self->box);
	G_OBJECT_CLASS (headerbar_parent_class)->finalize (obj);
}

GType
headerbar_get_type (void)
{
	static volatile gsize headerbar_type_id__volatile = 0;
	if (g_once_init_enter (&headerbar_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (HeaderbarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) headerbar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Headerbar), 0, (GInstanceInitFunc) headerbar_instance_init, NULL };
		GType headerbar_type_id;
		headerbar_type_id = g_type_register_static (gtk_header_bar_get_type (), "Headerbar", &g_define_type_info, 0);
		Headerbar_private_offset = g_type_add_instance_private (headerbar_type_id, sizeof (HeaderbarPrivate));
		g_once_init_leave (&headerbar_type_id__volatile, headerbar_type_id);
	}
	return headerbar_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

