/* settings.c generated by valac 0.46.6, the Vala compiler
 * generated from settings.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2018 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define TYPE_SETTINGS (settings_get_type ())
#define SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SETTINGS, Settings))
#define SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SETTINGS, SettingsClass))
#define IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SETTINGS))
#define IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SETTINGS))
#define SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SETTINGS, SettingsClass))

typedef struct _Settings Settings;
typedef struct _SettingsClass SettingsClass;
typedef struct _SettingsPrivate SettingsPrivate;
enum  {
	SETTINGS_0_PROPERTY,
	SETTINGS_NUM_PROPERTIES
};
static GParamSpec* settings_properties[SETTINGS_NUM_PROPERTIES];

#define TYPE_KEY (key_get_type ())
#define KEY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KEY, Key))
#define KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KEY, KeyClass))
#define IS_KEY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KEY))
#define IS_KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KEY))
#define KEY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KEY, KeyClass))

typedef struct _Key Key;
typedef struct _KeyClass KeyClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef enum  {
	DEBUG_DOMAIN_ERROR,
	DEBUG_DOMAIN_INFO,
	DEBUG_DOMAIN_HAMACHI,
	DEBUG_DOMAIN_ENVIRONMENT,
	DEBUG_DOMAIN_GUI
} Debugdomain;

#define DEBUG_TYPE_DOMAIN (debug_domain_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))

struct _Settings {
	GObject parent_instance;
	SettingsPrivate * priv;
};

struct _SettingsClass {
	GObjectClass parent_class;
};

static gpointer settings_parent_class = NULL;
extern gint settings_decorator_offset;
gint settings_decorator_offset = 0;
extern gint settings_switch_layout_threshold;
gint settings_switch_layout_threshold = 0;
extern gint settings_switch_sidebar_threshold;
gint settings_switch_sidebar_threshold = 0;
extern Key* settings_connect_on_startup;
Key* settings_connect_on_startup = NULL;
extern Key* settings_disconnect_on_quit;
Key* settings_disconnect_on_quit = NULL;
extern Key* settings_reconnect_on_connection_loss;
Key* settings_reconnect_on_connection_loss = NULL;
extern Key* settings_update_network_list;
Key* settings_update_network_list = NULL;
extern Key* settings_custom_commands;
Key* settings_custom_commands = NULL;
extern Key* settings_init_system;
Key* settings_init_system = NULL;
extern Key* settings_super_user;
Key* settings_super_user = NULL;
extern Key* settings_check_internet_hostname;
Key* settings_check_internet_hostname = NULL;
extern Key* settings_check_internet_ip;
Key* settings_check_internet_ip = NULL;
extern Key* settings_nickname;
Key* settings_nickname = NULL;
extern Key* settings_protocol;
Key* settings_protocol = NULL;
extern Key* settings_reconnect_interval;
Key* settings_reconnect_interval = NULL;
extern Key* settings_update_interval;
Key* settings_update_interval = NULL;
extern Key* settings_collapsed_networks;
Key* settings_collapsed_networks = NULL;
extern Key* settings_long_nicks;
Key* settings_long_nicks = NULL;
extern Key* settings_member_template_large;
Key* settings_member_template_large = NULL;
extern Key* settings_member_template_small;
Key* settings_member_template_small = NULL;
extern Key* settings_network_template_large;
Key* settings_network_template_large = NULL;
extern Key* settings_network_template_small;
Key* settings_network_template_small = NULL;
extern Key* settings_show_offline_members;
Key* settings_show_offline_members = NULL;
extern Key* settings_sort_network_list_by;
Key* settings_sort_network_list_by = NULL;
extern Key* settings_notify_on_connection_loss;
Key* settings_notify_on_connection_loss = NULL;
extern Key* settings_notify_on_member_join;
Key* settings_notify_on_member_join = NULL;
extern Key* settings_notify_on_member_leave;
Key* settings_notify_on_member_leave = NULL;
extern Key* settings_notify_on_member_offline;
Key* settings_notify_on_member_offline = NULL;
extern Key* settings_notify_on_member_online;
Key* settings_notify_on_member_online = NULL;
extern Key* settings_height;
Key* settings_height = NULL;
extern Key* settings_position_x;
Key* settings_position_x = NULL;
extern Key* settings_position_y;
Key* settings_position_y = NULL;
extern Key* settings_prefer_dark_theme;
Key* settings_prefer_dark_theme = NULL;
extern Key* settings_show_indicator;
Key* settings_show_indicator = NULL;
extern Key* settings_sidebar_position;
Key* settings_sidebar_position = NULL;
extern Key* settings_width;
Key* settings_width = NULL;

GType settings_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Settings, g_object_unref)
GType key_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Key, g_object_unref)
#define SETTINGS_schema_base_id "com.github.ztefn.haguichi"
void settings_init (void);
void settings_check (void);
Key* key_new (const gchar* _parent,
              const gchar* _key_name);
Key* key_construct (GType object_type,
                    const gchar* _parent,
                    const gchar* _key_name);
static gint _variant_get68 (GVariant* value);
GType debug_domain_get_type (void) G_GNUC_CONST;
void debug_log (Debugdomain _domain,
                const gchar* reporter,
                const gchar* output);
static GVariant* _variant_new11 (gint value);
gboolean command_exists (const gchar* command);
gchar* command_return_output (const gchar* command);
Settings* settings_new (void);
Settings* settings_construct (GType object_type);
static void settings_finalize (GObject * obj);

void
settings_init (void)
{
	Key* _tmp0_;
	Key* _tmp1_;
	Key* _tmp2_;
	Key* _tmp3_;
	Key* _tmp4_;
	Key* _tmp5_;
	Key* _tmp6_;
	Key* _tmp7_;
	Key* _tmp8_;
	Key* _tmp9_;
	Key* _tmp10_;
	Key* _tmp11_;
	Key* _tmp12_;
	Key* _tmp13_;
	Key* _tmp14_;
	Key* _tmp15_;
	Key* _tmp16_;
	Key* _tmp17_;
	Key* _tmp18_;
	Key* _tmp19_;
	Key* _tmp20_;
	Key* _tmp21_;
	Key* _tmp22_;
	Key* _tmp23_;
	Key* _tmp24_;
	Key* _tmp25_;
	Key* _tmp26_;
	Key* _tmp27_;
	Key* _tmp28_;
	Key* _tmp29_;
	Key* _tmp30_;
	Key* _tmp31_;
	Key* _tmp32_;
	settings_check ();
	settings_decorator_offset = 0;
	settings_switch_layout_threshold = 620;
	settings_switch_sidebar_threshold = 480;
	_tmp0_ = key_new ("behavior", "connect-on-startup");
	_g_object_unref0 (settings_connect_on_startup);
	settings_connect_on_startup = _tmp0_;
	_tmp1_ = key_new ("behavior", "disconnect-on-quit");
	_g_object_unref0 (settings_disconnect_on_quit);
	settings_disconnect_on_quit = _tmp1_;
	_tmp2_ = key_new ("behavior", "reconnect-on-connection-loss");
	_g_object_unref0 (settings_reconnect_on_connection_loss);
	settings_reconnect_on_connection_loss = _tmp2_;
	_tmp3_ = key_new ("behavior", "update-network-list");
	_g_object_unref0 (settings_update_network_list);
	settings_update_network_list = _tmp3_;
	_tmp4_ = key_new ("commands", "customizable");
	_g_object_unref0 (settings_custom_commands);
	settings_custom_commands = _tmp4_;
	_tmp5_ = key_new ("commands", "init-system");
	_g_object_unref0 (settings_init_system);
	settings_init_system = _tmp5_;
	_tmp6_ = key_new ("commands", "super-user");
	_g_object_unref0 (settings_super_user);
	settings_super_user = _tmp6_;
	_tmp7_ = key_new ("config", "check-internet-hostname");
	_g_object_unref0 (settings_check_internet_hostname);
	settings_check_internet_hostname = _tmp7_;
	_tmp8_ = key_new ("config", "check-internet-ip");
	_g_object_unref0 (settings_check_internet_ip);
	settings_check_internet_ip = _tmp8_;
	_tmp9_ = key_new ("config", "nickname");
	_g_object_unref0 (settings_nickname);
	settings_nickname = _tmp9_;
	_tmp10_ = key_new ("config", "protocol");
	_g_object_unref0 (settings_protocol);
	settings_protocol = _tmp10_;
	_tmp11_ = key_new ("config", "reconnect-interval");
	_g_object_unref0 (settings_reconnect_interval);
	settings_reconnect_interval = _tmp11_;
	_tmp12_ = key_new ("config", "update-interval");
	_g_object_unref0 (settings_update_interval);
	settings_update_interval = _tmp12_;
	_tmp13_ = key_new ("network-list", "collapsed-networks");
	_g_object_unref0 (settings_collapsed_networks);
	settings_collapsed_networks = _tmp13_;
	_tmp14_ = key_new ("network-list", "long-nicks");
	_g_object_unref0 (settings_long_nicks);
	settings_long_nicks = _tmp14_;
	_tmp15_ = key_new ("network-list", "member-template-large");
	_g_object_unref0 (settings_member_template_large);
	settings_member_template_large = _tmp15_;
	_tmp16_ = key_new ("network-list", "member-template-small");
	_g_object_unref0 (settings_member_template_small);
	settings_member_template_small = _tmp16_;
	_tmp17_ = key_new ("network-list", "network-template-large");
	_g_object_unref0 (settings_network_template_large);
	settings_network_template_large = _tmp17_;
	_tmp18_ = key_new ("network-list", "network-template-small");
	_g_object_unref0 (settings_network_template_small);
	settings_network_template_small = _tmp18_;
	_tmp19_ = key_new ("network-list", "show-offline-members");
	_g_object_unref0 (settings_show_offline_members);
	settings_show_offline_members = _tmp19_;
	_tmp20_ = key_new ("network-list", "sort-by");
	_g_object_unref0 (settings_sort_network_list_by);
	settings_sort_network_list_by = _tmp20_;
	_tmp21_ = key_new ("notifications", "connection-loss");
	_g_object_unref0 (settings_notify_on_connection_loss);
	settings_notify_on_connection_loss = _tmp21_;
	_tmp22_ = key_new ("notifications", "member-join");
	_g_object_unref0 (settings_notify_on_member_join);
	settings_notify_on_member_join = _tmp22_;
	_tmp23_ = key_new ("notifications", "member-leave");
	_g_object_unref0 (settings_notify_on_member_leave);
	settings_notify_on_member_leave = _tmp23_;
	_tmp24_ = key_new ("notifications", "member-offline");
	_g_object_unref0 (settings_notify_on_member_offline);
	settings_notify_on_member_offline = _tmp24_;
	_tmp25_ = key_new ("notifications", "member-online");
	_g_object_unref0 (settings_notify_on_member_online);
	settings_notify_on_member_online = _tmp25_;
	_tmp26_ = key_new ("ui", "height");
	_g_object_unref0 (settings_height);
	settings_height = _tmp26_;
	_tmp27_ = key_new ("ui", "position-x");
	_g_object_unref0 (settings_position_x);
	settings_position_x = _tmp27_;
	_tmp28_ = key_new ("ui", "position-y");
	_g_object_unref0 (settings_position_y);
	settings_position_y = _tmp28_;
	_tmp29_ = key_new ("ui", "prefer-dark-theme");
	_g_object_unref0 (settings_prefer_dark_theme);
	settings_prefer_dark_theme = _tmp29_;
	_tmp30_ = key_new ("ui", "show-indicator");
	_g_object_unref0 (settings_show_indicator);
	settings_show_indicator = _tmp30_;
	_tmp31_ = key_new ("ui", "sidebar-position");
	_g_object_unref0 (settings_sidebar_position);
	settings_sidebar_position = _tmp31_;
	_tmp32_ = key_new ("ui", "width");
	_g_object_unref0 (settings_width);
	settings_width = _tmp32_;
}

static gint
_variant_get68 (GVariant* value)
{
	return g_variant_get_int32 (value);
}

static GVariant*
_variant_new11 (gint value)
{
	return g_variant_ref_sink (g_variant_new_int32 (value));
}

void
settings_check (void)
{
	GSettings* base_schema = NULL;
	GSettings* _tmp0_;
	gint stamp = 0;
	GSettings* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	_tmp0_ = g_settings_new (SETTINGS_schema_base_id);
	base_schema = _tmp0_;
	_tmp1_ = base_schema;
	_tmp2_ = g_settings_get_value (_tmp1_, "stamp");
	_tmp3_ = _tmp2_;
	_tmp4_ = _variant_get68 (_tmp3_);
	_tmp5_ = _tmp4_;
	_g_variant_unref0 (_tmp3_);
	stamp = _tmp5_;
	_tmp6_ = g_strdup_printf ("%i", stamp);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_strconcat ("Settings are on stamp ", _tmp7_, NULL);
	_tmp9_ = _tmp8_;
	debug_log (DEBUG_DOMAIN_ENVIRONMENT, "Settings.check", _tmp9_);
	_g_free0 (_tmp9_);
	_g_free0 (_tmp7_);
	if (stamp == 1) {
		GSettings* _tmp10_;
		GVariant* _tmp11_;
		_tmp10_ = base_schema;
		_tmp11_ = _variant_new11 (2);
		g_settings_set_value (_tmp10_, "stamp", _tmp11_);
		_g_variant_unref0 (_tmp11_);
		debug_log (DEBUG_DOMAIN_ENVIRONMENT, "Settings.check", "Migrating user settings to new schema location...");
		if (command_exists ("dconf")) {
			gchar* _tmp12_;
			gchar* _tmp13_;
			_tmp12_ = command_return_output ("bash -c \"dconf dump /org/haguichi/ | dconf load /com/github/ztefn/hag" \
"uichi/; dconf reset -f /org/haguichi/\"");
			_tmp13_ = _tmp12_;
			_g_free0 (_tmp13_);
		} else {
			debug_log (DEBUG_DOMAIN_ERROR, "Settings.check", "DConf command is not available");
		}
	}
	_g_object_unref0 (base_schema);
}

Settings*
settings_construct (GType object_type)
{
	Settings * self = NULL;
	self = (Settings*) g_object_new (object_type, NULL);
	return self;
}

Settings*
settings_new (void)
{
	return settings_construct (TYPE_SETTINGS);
}

static void
settings_class_init (SettingsClass * klass,
                     gpointer klass_data)
{
	settings_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = settings_finalize;
}

static void
settings_instance_init (Settings * self,
                        gpointer klass)
{
}

static void
settings_finalize (GObject * obj)
{
	Settings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SETTINGS, Settings);
	G_OBJECT_CLASS (settings_parent_class)->finalize (obj);
}

GType
settings_get_type (void)
{
	static volatile gsize settings_type_id__volatile = 0;
	if (g_once_init_enter (&settings_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Settings), 0, (GInstanceInitFunc) settings_instance_init, NULL };
		GType settings_type_id;
		settings_type_id = g_type_register_static (G_TYPE_OBJECT, "Settings", &g_define_type_info, 0);
		g_once_init_leave (&settings_type_id__volatile, settings_type_id);
	}
	return settings_type_id__volatile;
}

