/* status.c generated by valac 0.46.6, the Vala compiler
 * generated from status.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2018 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#define TYPE_STATUS (status_get_type ())
#define STATUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATUS, Status))
#define STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATUS, StatusClass))
#define IS_STATUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATUS))
#define IS_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATUS))
#define STATUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATUS, StatusClass))

typedef struct _Status Status;
typedef struct _StatusClass StatusClass;
typedef struct _StatusPrivate StatusPrivate;
enum  {
	STATUS_0_PROPERTY,
	STATUS_NUM_PROPERTIES
};
static GParamSpec* status_properties[STATUS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _Status {
	GObject parent_instance;
	StatusPrivate * priv;
	gint status_int;
	gchar* status_text;
	gchar* status_sortable;
	gchar* message;
	gchar* connection_type;
};

struct _StatusClass {
	GObjectClass parent_class;
};

static gpointer status_parent_class = NULL;
extern gchar* text_offline;
extern gchar* text_online;
extern gchar* text_relayed;
extern gchar* text_unreachable;
extern gchar* text_unapproved;
extern gchar* text_error_unknown;
extern gchar* text_mismatch;
extern gchar* text_conflict;
extern gchar* text_direct;

GType status_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Status, g_object_unref)
Status* status_new (const gchar* status);
Status* status_construct (GType object_type,
                          const gchar* status);
void status_set_status (Status* self,
                        const gchar* status);
Status* status_new_complete (const gchar* status,
                             const gchar* connection,
                             const gchar* _message);
Status* status_construct_complete (GType object_type,
                                   const gchar* status,
                                   const gchar* connection,
                                   const gchar* _message);
static void status_set_connection_type (Status* self,
                                 const gchar* connection);
gchar* status_get_icon_name (Status* self);
static void status_finalize (GObject * obj);

Status*
status_construct (GType object_type,
                  const gchar* status)
{
	Status * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (status != NULL, NULL);
	self = (Status*) g_object_new (object_type, NULL);
	_tmp0_ = g_strdup ("");
	_g_free0 (self->message);
	self->message = _tmp0_;
	_tmp1_ = g_strdup ("");
	_g_free0 (self->connection_type);
	self->connection_type = _tmp1_;
	status_set_status (self, status);
	return self;
}

Status*
status_new (const gchar* status)
{
	return status_construct (TYPE_STATUS, status);
}

Status*
status_construct_complete (GType object_type,
                           const gchar* status,
                           const gchar* connection,
                           const gchar* _message)
{
	Status * self = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (status != NULL, NULL);
	self = (Status*) g_object_new (object_type, NULL);
	_tmp0_ = g_strdup (_message);
	_g_free0 (self->message);
	self->message = _tmp0_;
	status_set_connection_type (self, connection);
	status_set_status (self, status);
	return self;
}

Status*
status_new_complete (const gchar* status,
                     const gchar* connection,
                     const gchar* _message)
{
	return status_construct_complete (TYPE_STATUS, status, connection, _message);
}

void
status_set_status (Status* self,
                   const gchar* status)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (status != NULL);
	if (g_strcmp0 (status, " ") == 0) {
		const gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		self->status_int = 0;
		_tmp0_ = text_offline;
		_tmp1_ = g_strdup (_tmp0_);
		_g_free0 (self->status_text);
		self->status_text = _tmp1_;
		_tmp2_ = g_strdup ("f");
		_g_free0 (self->status_sortable);
		self->status_sortable = _tmp2_;
	} else {
		if (g_strcmp0 (status, "*") == 0) {
			const gchar* _tmp3_;
			gchar* _tmp4_;
			const gchar* _tmp5_;
			const gchar* _tmp6_;
			self->status_int = 1;
			_tmp3_ = text_online;
			_tmp4_ = g_strdup (_tmp3_);
			_g_free0 (self->status_text);
			self->status_text = _tmp4_;
			_tmp5_ = self->connection_type;
			_tmp6_ = text_relayed;
			if (g_strcmp0 (_tmp5_, _tmp6_) == 0) {
				gchar* _tmp7_;
				_tmp7_ = g_strdup ("b");
				_g_free0 (self->status_sortable);
				self->status_sortable = _tmp7_;
			} else {
				gchar* _tmp8_;
				_tmp8_ = g_strdup ("a");
				_g_free0 (self->status_sortable);
				self->status_sortable = _tmp8_;
			}
		} else {
			if (g_strcmp0 (status, "x") == 0) {
				const gchar* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				self->status_int = 2;
				_tmp9_ = text_unreachable;
				_tmp10_ = g_strdup (_tmp9_);
				_g_free0 (self->status_text);
				self->status_text = _tmp10_;
				_tmp11_ = g_strdup ("d");
				_g_free0 (self->status_sortable);
				self->status_sortable = _tmp11_;
			} else {
				if (g_strcmp0 (status, "?") == 0) {
					const gchar* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
					self->status_int = 3;
					_tmp12_ = text_unapproved;
					_tmp13_ = g_strdup (_tmp12_);
					_g_free0 (self->status_text);
					self->status_text = _tmp13_;
					_tmp14_ = g_strdup ("c");
					_g_free0 (self->status_sortable);
					self->status_sortable = _tmp14_;
				} else {
					if (g_strcmp0 (status, "!") == 0) {
						const gchar* _tmp15_;
						gchar* _tmp16_;
						gchar* _tmp17_;
						const gchar* _tmp18_;
						self->status_int = 4;
						_tmp15_ = text_error_unknown;
						_tmp16_ = g_strdup (_tmp15_);
						_g_free0 (self->status_text);
						self->status_text = _tmp16_;
						_tmp17_ = g_strdup ("e");
						_g_free0 (self->status_sortable);
						self->status_sortable = _tmp17_;
						_tmp18_ = self->message;
						if (g_strcmp0 (_tmp18_, "IP protocol mismatch between you and peer") == 0) {
							const gchar* _tmp19_;
							gchar* _tmp20_;
							_tmp19_ = text_mismatch;
							_tmp20_ = g_strdup (_tmp19_);
							_g_free0 (self->status_text);
							self->status_text = _tmp20_;
						} else {
							const gchar* _tmp21_;
							_tmp21_ = self->message;
							if (g_strcmp0 (_tmp21_, "This address is also used by another peer") == 0) {
								const gchar* _tmp22_;
								gchar* _tmp23_;
								_tmp22_ = text_conflict;
								_tmp23_ = g_strdup (_tmp22_);
								_g_free0 (self->status_text);
								self->status_text = _tmp23_;
							}
						}
					}
				}
			}
		}
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static void
status_set_connection_type (Status* self,
                            const gchar* connection)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup ("");
	_g_free0 (self->connection_type);
	self->connection_type = _tmp0_;
	if (connection == NULL) {
		return;
	} else {
		if (g_strcmp0 (connection, "direct") == 0) {
			const gchar* _tmp1_;
			gchar* _tmp2_;
			_tmp1_ = text_direct;
			_tmp2_ = g_strdup (_tmp1_);
			_g_free0 (self->connection_type);
			self->connection_type = _tmp2_;
		} else {
			if (string_contains (connection, "via ")) {
				const gchar* _tmp3_;
				gchar* _tmp4_;
				_tmp3_ = text_relayed;
				_tmp4_ = g_strdup (_tmp3_);
				_g_free0 (self->connection_type);
				self->connection_type = _tmp4_;
			}
		}
	}
}

gchar*
status_get_icon_name (Status* self)
{
	gchar* icon_name = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup ("");
	icon_name = _tmp0_;
	if (self->status_int == 0) {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("haguichi-node-offline");
		_g_free0 (icon_name);
		icon_name = _tmp1_;
	}
	if (self->status_int == 1) {
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		_tmp2_ = self->connection_type;
		_tmp3_ = text_relayed;
		if (g_strcmp0 (_tmp2_, _tmp3_) == 0) {
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("haguichi-node-online-relayed");
			_g_free0 (icon_name);
			icon_name = _tmp4_;
		} else {
			gchar* _tmp5_;
			_tmp5_ = g_strdup ("haguichi-node-online");
			_g_free0 (icon_name);
			icon_name = _tmp5_;
		}
	} else {
		if (self->status_int == 2) {
			gchar* _tmp6_;
			_tmp6_ = g_strdup ("haguichi-node-unreachable");
			_g_free0 (icon_name);
			icon_name = _tmp6_;
		} else {
			if (self->status_int == 3) {
				gchar* _tmp7_;
				_tmp7_ = g_strdup ("haguichi-node-unapproved");
				_g_free0 (icon_name);
				icon_name = _tmp7_;
			} else {
				if (self->status_int == 4) {
					gchar* _tmp8_;
					_tmp8_ = g_strdup ("haguichi-node-error");
					_g_free0 (icon_name);
					icon_name = _tmp8_;
				}
			}
		}
	}
	result = icon_name;
	return result;
}

static void
status_class_init (StatusClass * klass,
                   gpointer klass_data)
{
	status_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = status_finalize;
}

static void
status_instance_init (Status * self,
                      gpointer klass)
{
}

static void
status_finalize (GObject * obj)
{
	Status * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_STATUS, Status);
	_g_free0 (self->status_text);
	_g_free0 (self->status_sortable);
	_g_free0 (self->message);
	_g_free0 (self->connection_type);
	G_OBJECT_CLASS (status_parent_class)->finalize (obj);
}

GType
status_get_type (void)
{
	static volatile gsize status_type_id__volatile = 0;
	if (g_once_init_enter (&status_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (StatusClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) status_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Status), 0, (GInstanceInitFunc) status_instance_init, NULL };
		GType status_type_id;
		status_type_id = g_type_register_static (G_TYPE_OBJECT, "Status", &g_define_type_info, 0);
		g_once_init_leave (&status_type_id__volatile, status_type_id);
	}
	return status_type_id__volatile;
}

