/* utils.c generated by valac 0.46.6, the Vala compiler
 * generated from utils.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2018 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>

#define TYPE_UTILS (utils_get_type ())
#define UTILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UTILS, Utils))
#define UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UTILS, UtilsClass))
#define IS_UTILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UTILS))
#define IS_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UTILS))
#define UTILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UTILS, UtilsClass))

typedef struct _Utils Utils;
typedef struct _UtilsClass UtilsClass;
typedef struct _UtilsPrivate UtilsPrivate;
enum  {
	UTILS_0_PROPERTY,
	UTILS_NUM_PROPERTIES
};
static GParamSpec* utils_properties[UTILS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef enum  {
	DEBUG_DOMAIN_ERROR,
	DEBUG_DOMAIN_INFO,
	DEBUG_DOMAIN_HAMACHI,
	DEBUG_DOMAIN_ENVIRONMENT,
	DEBUG_DOMAIN_GUI
} Debugdomain;

#define DEBUG_TYPE_DOMAIN (debug_domain_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _Utils {
	GObject parent_instance;
	UtilsPrivate * priv;
};

struct _UtilsClass {
	GObjectClass parent_class;
};

static gpointer utils_parent_class = NULL;

GType utils_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Utils, g_object_unref)
gchar* utils_format (gchar* text,
                     const gchar* param1,
                     const gchar* param2,
                     const gchar* param3);
gchar* utils_remove_mnemonics (gchar* label);
GType debug_domain_get_type (void) G_GNUC_CONST;
void debug_log (Debugdomain _domain,
                const gchar* reporter,
                const gchar* output);
gchar* utils_remove_colons (gchar* label);
gchar* utils_as_string (gchar** commands,
                        gint commands_length1);
gchar* utils_clean_string (gchar* _string);
gchar* utils_protocol_to_string (gint protocol);
gint utils_protocol_to_int (const gchar* protocol);
gchar* utils_get_message_type_icon_name (GtkMessageType message_type);
gchar* utils_get_available_theme_icon (gchar** icon_names,
                                       gint icon_names_length1);
GtkLabel* utils_get_label_widget (GtkContainer* container);
Utils* utils_new (void);
Utils* utils_construct (GType object_type);

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch27_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch27_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally27;
	__catch27_g_regex_error:
	{
		GError* e = NULL;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally27:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

gchar*
utils_format (gchar* text,
              const gchar* param1,
              const gchar* param2,
              const gchar* param3)
{
	gchar* _tmp6_;
	gchar* result = NULL;
	g_return_val_if_fail (text != NULL, NULL);
	if (param1 == NULL) {
		gchar* _tmp0_;
		_tmp0_ = string_replace (text, "{0}", "");
		_g_free0 (text);
		text = _tmp0_;
	}
	if (param2 == NULL) {
		gchar* _tmp1_;
		_tmp1_ = string_replace (text, "{1}", "");
		_g_free0 (text);
		text = _tmp1_;
	}
	if (param3 == NULL) {
		gchar* _tmp2_;
		_tmp2_ = string_replace (text, "{2}", "");
		_g_free0 (text);
		text = _tmp2_;
	}
	if (param1 != NULL) {
		gchar* _tmp3_;
		_tmp3_ = string_replace (text, "{0}", param1);
		_g_free0 (text);
		text = _tmp3_;
	}
	if (param2 != NULL) {
		gchar* _tmp4_;
		_tmp4_ = string_replace (text, "{1}", param2);
		_g_free0 (text);
		text = _tmp4_;
	}
	if (param3 != NULL) {
		gchar* _tmp5_;
		_tmp5_ = string_replace (text, "{2}", param3);
		_g_free0 (text);
		text = _tmp5_;
	}
	_tmp6_ = g_strdup (text);
	result = _tmp6_;
	_g_free0 (text);
	return result;
}

gchar*
utils_remove_mnemonics (gchar* label)
{
	gchar* _tmp8_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (label != NULL, NULL);
	{
		GRegex* _tmp0_ = NULL;
		GRegex* _tmp1_;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp1_ = g_regex_new ("\\(_[a-zA-Z]\\)", 0, 0, &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch28_g_regex_error;
			}
			_g_free0 (label);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp3_ = g_regex_replace (_tmp0_, label, (gssize) -1, 0, "", 0, &_inner_error0_);
		_tmp2_ = _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (_tmp0_);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch28_g_regex_error;
			}
			_g_free0 (label);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp4_ = _tmp2_;
		_tmp2_ = NULL;
		_g_free0 (label);
		label = _tmp4_;
		_tmp5_ = string_replace (label, "_", "");
		_g_free0 (label);
		label = _tmp5_;
		_g_free0 (_tmp2_);
		_g_regex_unref0 (_tmp0_);
	}
	goto __finally28;
	__catch28_g_regex_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp6_ = e;
		_tmp7_ = _tmp6_->message;
		debug_log (DEBUG_DOMAIN_ERROR, "Utils.remove_mnemonics", _tmp7_);
		_g_error_free0 (e);
	}
	__finally28:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (label);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_tmp8_ = g_strdup (label);
	result = _tmp8_;
	_g_free0 (label);
	return result;
}

gchar*
utils_remove_colons (gchar* label)
{
	gchar* _tmp2_;
	gchar* result = NULL;
	if (label != NULL) {
		gchar* _tmp0_;
		gchar* _tmp1_;
		_tmp0_ = string_replace (label, " :", "");
		_g_free0 (label);
		label = _tmp0_;
		_tmp1_ = string_replace (label, ":", "");
		_g_free0 (label);
		label = _tmp1_;
	}
	_tmp2_ = g_strdup (label);
	result = _tmp2_;
	_g_free0 (label);
	return result;
}

gchar*
utils_as_string (gchar** commands,
                 gint commands_length1)
{
	gchar* output = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
	_tmp0_ = g_strdup ("");
	output = _tmp0_;
	{
		gchar** c_collection = NULL;
		gint c_collection_length1 = 0;
		gint _c_collection_size_ = 0;
		gint c_it = 0;
		c_collection = commands;
		c_collection_length1 = commands_length1;
		for (c_it = 0; c_it < c_collection_length1; c_it = c_it + 1) {
			gchar* _tmp1_;
			gchar* c = NULL;
			_tmp1_ = g_strdup (c_collection[c_it]);
			c = _tmp1_;
			{
				const gchar* _tmp2_;
				const gchar* _tmp3_;
				gchar* _tmp4_;
				_tmp2_ = output;
				_tmp3_ = c;
				_tmp4_ = g_strconcat (_tmp2_, _tmp3_, NULL);
				_g_free0 (output);
				output = _tmp4_;
				_g_free0 (c);
			}
		}
	}
	result = output;
	return result;
}

gchar*
utils_clean_string (gchar* _string)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result = NULL;
	g_return_val_if_fail (_string != NULL, NULL);
	_tmp0_ = string_replace (_string, "\\", "\\\\");
	_g_free0 (_string);
	_string = _tmp0_;
	_tmp1_ = string_replace (_string, "\"", "\\\"");
	_g_free0 (_string);
	_string = _tmp1_;
	_tmp2_ = g_strdup (_string);
	result = _tmp2_;
	_g_free0 (_string);
	return result;
}

gchar*
utils_protocol_to_string (gint protocol)
{
	gchar* output = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
	_tmp0_ = g_strdup ("");
	output = _tmp0_;
	switch (protocol) {
		case 0:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("both");
			_g_free0 (output);
			output = _tmp1_;
			break;
		}
		case 1:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("ipv4");
			_g_free0 (output);
			output = _tmp2_;
			break;
		}
		case 2:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("ipv6");
			_g_free0 (output);
			output = _tmp3_;
			break;
		}
		default:
		break;
	}
	result = output;
	return result;
}

gint
utils_protocol_to_int (const gchar* protocol)
{
	gint output = 0;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	static GQuark _tmp1_label2 = 0;
	gint result = 0;
	g_return_val_if_fail (protocol != NULL, 0);
	output = 0;
	_tmp0_ = protocol;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("both")))) {
		switch (0) {
			default:
			{
				output = 0;
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("ipv4")))) {
		switch (0) {
			default:
			{
				output = 1;
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("ipv6")))) {
		switch (0) {
			default:
			{
				output = 2;
				break;
			}
		}
	}
	result = output;
	return result;
}

gchar*
utils_get_message_type_icon_name (GtkMessageType message_type)
{
	gchar* result = NULL;
	switch (message_type) {
		case GTK_MESSAGE_WARNING:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("dialog-warning");
			result = _tmp0_;
			return result;
		}
		case GTK_MESSAGE_QUESTION:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("dialog-question");
			result = _tmp1_;
			return result;
		}
		case GTK_MESSAGE_ERROR:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("dialog-error");
			result = _tmp2_;
			return result;
		}
		default:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("dialog-info");
			result = _tmp3_;
			return result;
		}
	}
}

gchar*
utils_get_available_theme_icon (gchar** icon_names,
                                gint icon_names_length1)
{
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result = NULL;
	{
		gchar** icon_name_collection = NULL;
		gint icon_name_collection_length1 = 0;
		gint _icon_name_collection_size_ = 0;
		gint icon_name_it = 0;
		icon_name_collection = icon_names;
		icon_name_collection_length1 = icon_names_length1;
		for (icon_name_it = 0; icon_name_it < icon_name_collection_length1; icon_name_it = icon_name_it + 1) {
			gchar* _tmp0_;
			gchar* icon_name = NULL;
			_tmp0_ = g_strdup (icon_name_collection[icon_name_it]);
			icon_name = _tmp0_;
			{
				GtkIconTheme* _tmp1_;
				const gchar* _tmp2_;
				_tmp1_ = gtk_icon_theme_get_default ();
				_tmp2_ = icon_name;
				if (gtk_icon_theme_has_icon (_tmp1_, _tmp2_)) {
					result = icon_name;
					return result;
				}
				_g_free0 (icon_name);
			}
		}
	}
	_tmp3_ = icon_names[0];
	_tmp4_ = g_strdup (_tmp3_);
	result = _tmp4_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

GtkLabel*
utils_get_label_widget (GtkContainer* container)
{
	GList* _tmp0_;
	GtkLabel* result = NULL;
	g_return_val_if_fail (container != NULL, NULL);
	_tmp0_ = gtk_container_get_children (container);
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
		child_collection = _tmp0_;
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkWidget* _tmp1_;
			GtkWidget* child = NULL;
			_tmp1_ = _g_object_ref0 ((GtkWidget*) child_it->data);
			child = _tmp1_;
			{
				GtkLabel* label = NULL;
				GtkWidget* _tmp2_;
				GtkLabel* _tmp3_;
				GtkLabel* _tmp4_;
				_tmp2_ = child;
				_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_label_get_type ()) ? ((GtkLabel*) _tmp2_) : NULL);
				label = _tmp3_;
				_tmp4_ = label;
				if (_tmp4_ != NULL) {
					result = label;
					_g_object_unref0 (child);
					(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
					return result;
				}
				_g_object_unref0 (label);
				_g_object_unref0 (child);
			}
		}
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
	}
	result = NULL;
	return result;
}

Utils*
utils_construct (GType object_type)
{
	Utils * self = NULL;
	self = (Utils*) g_object_new (object_type, NULL);
	return self;
}

Utils*
utils_new (void)
{
	return utils_construct (TYPE_UTILS);
}

static void
utils_class_init (UtilsClass * klass,
                  gpointer klass_data)
{
	utils_parent_class = g_type_class_peek_parent (klass);
}

static void
utils_instance_init (Utils * self,
                     gpointer klass)
{
}

GType
utils_get_type (void)
{
	static volatile gsize utils_type_id__volatile = 0;
	if (g_once_init_enter (&utils_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UtilsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) utils_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Utils), 0, (GInstanceInitFunc) utils_instance_init, NULL };
		GType utils_type_id;
		utils_type_id = g_type_register_static (G_TYPE_OBJECT, "Utils", &g_define_type_info, 0);
		g_once_init_leave (&utils_type_id__volatile, utils_type_id);
	}
	return utils_type_id__volatile;
}

