/* commands-editor-row.c generated by valac 0.46.6, the Vala compiler
 * generated from commands-editor-row.vala, do not modify */

/*
 * This file is part of Haguichi, a graphical frontend for Hamachi.
 * Copyright (C) 2007-2018 Stephen Brandt <stephen@stephenbrandt.com>
 *
 * Haguichi is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation, either version 3 of the License,
 * or (at your option) any later version.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#define TYPE_COMMANDS_EDITOR_ROW (commands_editor_row_get_type ())
#define COMMANDS_EDITOR_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMANDS_EDITOR_ROW, CommandsEditorRow))
#define COMMANDS_EDITOR_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMMANDS_EDITOR_ROW, CommandsEditorRowClass))
#define IS_COMMANDS_EDITOR_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMANDS_EDITOR_ROW))
#define IS_COMMANDS_EDITOR_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMMANDS_EDITOR_ROW))
#define COMMANDS_EDITOR_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMMANDS_EDITOR_ROW, CommandsEditorRowClass))

typedef struct _CommandsEditorRow CommandsEditorRow;
typedef struct _CommandsEditorRowClass CommandsEditorRowClass;
typedef struct _CommandsEditorRowPrivate CommandsEditorRowPrivate;

#define TYPE_COMMANDS_EDITOR (commands_editor_get_type ())
#define COMMANDS_EDITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMANDS_EDITOR, CommandsEditor))
#define COMMANDS_EDITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMMANDS_EDITOR, CommandsEditorClass))
#define IS_COMMANDS_EDITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMANDS_EDITOR))
#define IS_COMMANDS_EDITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMMANDS_EDITOR))
#define COMMANDS_EDITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMMANDS_EDITOR, CommandsEditorClass))

typedef struct _CommandsEditor CommandsEditor;
typedef struct _CommandsEditorClass CommandsEditorClass;
enum  {
	COMMANDS_EDITOR_ROW_0_PROPERTY,
	COMMANDS_EDITOR_ROW_NUM_PROPERTIES
};
static GParamSpec* commands_editor_row_properties[COMMANDS_EDITOR_ROW_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _CommandsEditorPrivate CommandsEditorPrivate;

struct _CommandsEditorRow {
	GtkListBoxRow parent_instance;
	CommandsEditorRowPrivate * priv;
	gboolean is_active;
	gboolean is_default;
	gchar* label;
	gchar* command_ipv4;
	gchar* command_ipv6;
	gchar* priority;
};

struct _CommandsEditorRowClass {
	GtkListBoxRowClass parent_class;
};

struct _CommandsEditorRowPrivate {
	CommandsEditor* editor;
	GtkLabel* title;
	GtkLabel* preview;
	GtkImage* img;
	GtkSwitch* swh;
};

struct _CommandsEditor {
	GtkBox parent_instance;
	CommandsEditorPrivate * priv;
	gchar** default_icon_names;
	gint default_icon_names_length1;
};

struct _CommandsEditorClass {
	GtkBoxClass parent_class;
};

static gint CommandsEditorRow_private_offset;
static gpointer commands_editor_row_parent_class = NULL;

GType commands_editor_row_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CommandsEditorRow, g_object_unref)
GType commands_editor_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CommandsEditor, g_object_unref)
CommandsEditorRow* commands_editor_row_new (CommandsEditor* _editor,
                                            gboolean _is_active,
                                            gboolean _is_default,
                                            const gchar* _label,
                                            const gchar* _command_ipv4,
                                            const gchar* _command_ipv6,
                                            const gchar* _priority);
CommandsEditorRow* commands_editor_row_construct (GType object_type,
                                                  CommandsEditor* _editor,
                                                  gboolean _is_active,
                                                  gboolean _is_default,
                                                  const gchar* _label,
                                                  const gchar* _command_ipv4,
                                                  const gchar* _command_ipv6,
                                                  const gchar* _priority);
static gboolean __lambda12_ (CommandsEditorRow* self,
                      gboolean state);
void commands_editor_update_commands (CommandsEditor* self);
static gboolean ___lambda12__gtk_switch_state_set (GtkSwitch* _sender,
                                            gboolean state,
                                            gpointer self);
void commands_editor_row_update (CommandsEditorRow* self,
                                 const gchar* _label,
                                 const gchar* _command_ipv4,
                                 const gchar* _command_ipv6,
                                 const gchar* _priority);
void commands_editor_row_set_default (CommandsEditorRow* self,
                                      gboolean _is_default);
gchar* utils_remove_mnemonics (gchar* label);
gchar* command_replace_variables (gchar* command,
                                  const gchar* address,
                                  const gchar* nick,
                                  const gchar* id);
gchar* utils_get_available_theme_icon (gchar** icon_names,
                                       gint icon_names_length1);
static void commands_editor_row_finalize (GObject * obj);

static inline gpointer
commands_editor_row_get_instance_private (CommandsEditorRow* self)
{
	return G_STRUCT_MEMBER_P (self, CommandsEditorRow_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
__lambda12_ (CommandsEditorRow* self,
             gboolean state)
{
	CommandsEditor* _tmp0_;
	gboolean result = FALSE;
	self->is_active = state;
	_tmp0_ = self->priv->editor;
	commands_editor_update_commands (_tmp0_);
	result = FALSE;
	return result;
}

static gboolean
___lambda12__gtk_switch_state_set (GtkSwitch* _sender,
                                   gboolean state,
                                   gpointer self)
{
	gboolean result;
	result = __lambda12_ ((CommandsEditorRow*) self, state);
	return result;
}

CommandsEditorRow*
commands_editor_row_construct (GType object_type,
                               CommandsEditor* _editor,
                               gboolean _is_active,
                               gboolean _is_default,
                               const gchar* _label,
                               const gchar* _command_ipv4,
                               const gchar* _command_ipv6,
                               const gchar* _priority)
{
	CommandsEditorRow * self = NULL;
	CommandsEditor* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkStyleContext* _tmp7_;
	GtkBox* label_box = NULL;
	GtkBox* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkImage* _tmp11_;
	GtkSwitch* _tmp12_;
	GtkSwitch* _tmp13_;
	GtkSwitch* _tmp14_;
	GtkSwitch* _tmp15_;
	GtkBox* box = NULL;
	GtkBox* _tmp16_;
	GtkImage* _tmp17_;
	GtkSwitch* _tmp18_;
	g_return_val_if_fail (_editor != NULL, NULL);
	g_return_val_if_fail (_label != NULL, NULL);
	g_return_val_if_fail (_command_ipv4 != NULL, NULL);
	g_return_val_if_fail (_command_ipv6 != NULL, NULL);
	g_return_val_if_fail (_priority != NULL, NULL);
	self = (CommandsEditorRow*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (_editor);
	_g_object_unref0 (self->priv->editor);
	self->priv->editor = _tmp0_;
	self->is_active = _is_active;
	self->is_default = _is_default;
	gtk_list_box_row_set_activatable ((GtkListBoxRow*) self, TRUE);
	gtk_list_box_row_set_selectable ((GtkListBoxRow*) self, TRUE);
	_tmp1_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->title);
	self->priv->title = _tmp1_;
	_tmp2_ = self->priv->title;
	gtk_label_set_xalign (_tmp2_, 0.0f);
	_tmp3_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->preview);
	self->priv->preview = _tmp3_;
	_tmp4_ = self->priv->preview;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp4_, 2);
	_tmp5_ = self->priv->preview;
	gtk_label_set_xalign (_tmp5_, 0.0f);
	_tmp6_ = self->priv->preview;
	_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) _tmp6_);
	gtk_style_context_add_class (_tmp7_, "dim-label");
	_tmp8_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	g_object_ref_sink (_tmp8_);
	label_box = _tmp8_;
	_tmp9_ = self->priv->title;
	gtk_box_pack_start (label_box, (GtkWidget*) _tmp9_, FALSE, FALSE, (guint) 0);
	_tmp10_ = self->priv->preview;
	gtk_box_pack_end (label_box, (GtkWidget*) _tmp10_, FALSE, FALSE, (guint) 0);
	gtk_widget_set_valign ((GtkWidget*) label_box, GTK_ALIGN_CENTER);
	_tmp11_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp11_);
	_g_object_unref0 (self->priv->img);
	self->priv->img = _tmp11_;
	_tmp12_ = (GtkSwitch*) gtk_switch_new ();
	g_object_ref_sink (_tmp12_);
	_g_object_unref0 (self->priv->swh);
	self->priv->swh = _tmp12_;
	_tmp13_ = self->priv->swh;
	gtk_switch_set_active (_tmp13_, self->is_active);
	_tmp14_ = self->priv->swh;
	gtk_widget_set_valign ((GtkWidget*) _tmp14_, GTK_ALIGN_CENTER);
	_tmp15_ = self->priv->swh;
	g_signal_connect_object (_tmp15_, "state-set", (GCallback) ___lambda12__gtk_switch_state_set, self, 0);
	_tmp16_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
	g_object_ref_sink (_tmp16_);
	box = _tmp16_;
	gtk_container_set_border_width ((GtkContainer*) box, (guint) 6);
	gtk_box_pack_start (box, (GtkWidget*) label_box, FALSE, FALSE, (guint) 4);
	_tmp17_ = self->priv->img;
	gtk_box_pack_start (box, (GtkWidget*) _tmp17_, FALSE, FALSE, (guint) 8);
	_tmp18_ = self->priv->swh;
	gtk_box_pack_end (box, (GtkWidget*) _tmp18_, FALSE, FALSE, (guint) 6);
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) box);
	commands_editor_row_update (self, _label, _command_ipv4, _command_ipv6, _priority);
	commands_editor_row_set_default (self, self->is_default);
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (box);
	_g_object_unref0 (label_box);
	return self;
}

CommandsEditorRow*
commands_editor_row_new (CommandsEditor* _editor,
                         gboolean _is_active,
                         gboolean _is_default,
                         const gchar* _label,
                         const gchar* _command_ipv4,
                         const gchar* _command_ipv6,
                         const gchar* _priority)
{
	return commands_editor_row_construct (TYPE_COMMANDS_EDITOR_ROW, _editor, _is_active, _is_default, _label, _command_ipv4, _command_ipv6, _priority);
}

void
commands_editor_row_update (CommandsEditorRow* self,
                            const gchar* _label,
                            const gchar* _command_ipv4,
                            const gchar* _command_ipv6,
                            const gchar* _priority)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_;
	gchar* command = NULL;
	gchar* _tmp8_;
	const gchar* _tmp9_ = NULL;
	const gchar* _tmp10_;
	gchar* address = NULL;
	gchar* _tmp11_;
	GtkLabel* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	GtkLabel* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_label != NULL);
	g_return_if_fail (_command_ipv4 != NULL);
	g_return_if_fail (_command_ipv6 != NULL);
	g_return_if_fail (_priority != NULL);
	_tmp0_ = g_strdup (_label);
	_g_free0 (self->label);
	self->label = _tmp0_;
	_tmp1_ = g_strdup (_command_ipv4);
	_g_free0 (self->command_ipv4);
	self->command_ipv4 = _tmp1_;
	_tmp2_ = g_strdup (_command_ipv6);
	_g_free0 (self->command_ipv6);
	self->command_ipv6 = _tmp2_;
	_tmp3_ = g_strdup (_priority);
	_g_free0 (self->priority);
	self->priority = _tmp3_;
	_tmp5_ = self->priority;
	if (g_strcmp0 (_tmp5_, "IPv6") == 0) {
		const gchar* _tmp6_;
		_tmp6_ = self->command_ipv6;
		_tmp4_ = _tmp6_;
	} else {
		const gchar* _tmp7_;
		_tmp7_ = self->command_ipv4;
		_tmp4_ = _tmp7_;
	}
	_tmp8_ = g_strdup (_tmp4_);
	command = _tmp8_;
	_tmp10_ = self->priority;
	if (g_strcmp0 (_tmp10_, "IPv6") == 0) {
		_tmp9_ = "2620:9b::56d:f78e";
	} else {
		_tmp9_ = "25.123.456.78";
	}
	_tmp11_ = g_strdup (_tmp9_);
	address = _tmp11_;
	_tmp12_ = self->priv->title;
	_tmp13_ = self->label;
	_tmp14_ = g_strdup (_ (_tmp13_));
	_tmp15_ = utils_remove_mnemonics (_tmp14_);
	_tmp16_ = _tmp15_;
	gtk_label_set_label (_tmp12_, _tmp16_);
	_g_free0 (_tmp16_);
	_tmp17_ = self->priv->preview;
	_tmp18_ = command;
	_tmp19_ = g_strdup (_tmp18_);
	_tmp20_ = command_replace_variables (_tmp19_, address, "Nick", "090-123-456");
	_tmp21_ = _tmp20_;
	gtk_label_set_label (_tmp17_, _tmp21_);
	_g_free0 (_tmp21_);
	_g_free0 (address);
	_g_free0 (command);
}

void
commands_editor_row_set_default (CommandsEditorRow* self,
                                 gboolean _is_default)
{
	g_return_if_fail (self != NULL);
	self->is_default = _is_default;
	if (self->is_default) {
		GtkImage* _tmp0_;
		CommandsEditor* _tmp1_;
		gchar** _tmp2_;
		gint _tmp2__length1;
		gchar* _tmp3_;
		gchar* _tmp4_;
		_tmp0_ = self->priv->img;
		_tmp1_ = self->priv->editor;
		_tmp2_ = _tmp1_->default_icon_names;
		_tmp2__length1 = _tmp1_->default_icon_names_length1;
		_tmp3_ = utils_get_available_theme_icon (_tmp2_, (gint) _tmp2__length1);
		_tmp4_ = _tmp3_;
		gtk_image_set_from_icon_name (_tmp0_, _tmp4_, (GtkIconSize) GTK_ICON_SIZE_MENU);
		_g_free0 (_tmp4_);
	} else {
		GtkImage* _tmp5_;
		_tmp5_ = self->priv->img;
		gtk_image_clear (_tmp5_);
	}
}

static void
commands_editor_row_class_init (CommandsEditorRowClass * klass,
                                gpointer klass_data)
{
	commands_editor_row_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &CommandsEditorRow_private_offset);
	G_OBJECT_CLASS (klass)->finalize = commands_editor_row_finalize;
}

static void
commands_editor_row_instance_init (CommandsEditorRow * self,
                                   gpointer klass)
{
	self->priv = commands_editor_row_get_instance_private (self);
}

static void
commands_editor_row_finalize (GObject * obj)
{
	CommandsEditorRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COMMANDS_EDITOR_ROW, CommandsEditorRow);
	_g_free0 (self->label);
	_g_free0 (self->command_ipv4);
	_g_free0 (self->command_ipv6);
	_g_free0 (self->priority);
	_g_object_unref0 (self->priv->editor);
	_g_object_unref0 (self->priv->title);
	_g_object_unref0 (self->priv->preview);
	_g_object_unref0 (self->priv->img);
	_g_object_unref0 (self->priv->swh);
	G_OBJECT_CLASS (commands_editor_row_parent_class)->finalize (obj);
}

GType
commands_editor_row_get_type (void)
{
	static volatile gsize commands_editor_row_type_id__volatile = 0;
	if (g_once_init_enter (&commands_editor_row_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CommandsEditorRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) commands_editor_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CommandsEditorRow), 0, (GInstanceInitFunc) commands_editor_row_instance_init, NULL };
		GType commands_editor_row_type_id;
		commands_editor_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "CommandsEditorRow", &g_define_type_info, 0);
		CommandsEditorRow_private_offset = g_type_add_instance_private (commands_editor_row_type_id, sizeof (CommandsEditorRowPrivate));
		g_once_init_leave (&commands_editor_row_type_id__volatile, commands_editor_row_type_id);
	}
	return commands_editor_row_type_id__volatile;
}

